{******************************************************************************}
{**                                                                          **}
{**  Currency routines. (This is one of my oldest routins since BP6)         **}
{**                                                                          **}
{**  Author:    KARPOLAN                                                     **}
{**  E-Mail:    karpolan@yahoo.com , karpolan@utilmind.com                   **}
{**  Home Page: http://karpolan.i.am, http://www.utilmind.com                **}
{**  Copyright  1996-99 by KARPOLAN.                                        **}
{**  Copyright  1999, UtilMind Solutions.                                   **}
{**                                                                          **}
{******************************************************************************}
{**  History:                                                                **}
{**                                                                          **}
{**  31 aug 1999 - Last modified... Prepared for public release.             **}
{******************************************************************************}
Unit AntCurr;

{*******************************************************************************
   This unit is prepared for Ukranian currency... I've made it in 1994, and
convert it to Delphi in 1995. And I smile about this code but maybe you need
same routines. Convert it for your language if you want or keep this file as
example of BAD STYLE programming. :))))))
*******************************************************************************}

{$Include AntUnits.Inc}

Interface

Uses SysUtils;

Const
  Ones : Array[0..9] of String[10] =
    ('','','','','',
     '''','i','i','ii','''');
  OnesT : Array[0..9] of String[10] =
    ('','','i','','',
     '''','i','i','ii','''');
  Tens : Array[0..9] of String[15] =
    ('','','','','',
     '''','i','i',
     'ii','''');
  FirstTens : Array[0..9] of String[15] =
    ('','','','',
     '','''','i',
     'i','ii','''');
  Hundreds : Array[0..9] of String[10] =
    ('','','ii','',
     '','''','i',
     'i','ii','''');

Function GetName1e9(A : integer) : String;
Function GetName1e6(A : integer) : String;
Function GetName1e3(A : integer) : String;

Function FirstZero(AStr    : String;
                   ALength : integer) : String;

Function Num1000(A : integer) : String;
Function Num1000For1000(A : integer) : String;

Function NumToStrMale(A : Extended) : String;
Function NumToStrFemale(A : Extended) : String;

Function NumToValutaStr(A            : Extended;
                        ValName      : String;
                        CentName     : String;
                        ShowCent     : Boolean;
                        CentToNumber : Boolean;
                        Female       : Boolean) : String;

Function NumToUAH(A : Extended) : String;

Procedure DivBySpace(Source : String;
                     Len    : integer;
                     Var S1,
                         S2 : String);

{****************************************************************}
Implementation

{************************************}
{******* Get Name of Counters *******}
{************************************}
Function GetName1e9(A : integer) : String;
Var
  RegStr : String;
  RegInt : integer;
Begin
  try
    RegStr:=IntToStr(A);
    if (Length(RegStr)>1)
       and (RegStr[Length(RegStr)-1]='1')
     then RegInt:=5
     else RegInt:=StrToInt(RegStr[Length(RegStr)]);
  except
    RegInt:=1;
  end;{try .. except}
  case RegInt of
   1    : Result:='ii';
   2..4 : Result:='ii';
   else   Result:='iii';
  end;{case RegInt of}
End;{Function GetName1e9(A : integer)}

Function GetName1e6(A : integer) : String;
Var
  RegStr : String;
  RegInt : integer;
Begin
  try
    RegStr:=IntToStr(A);
    if (Length(RegStr)>1)
       and (RegStr[Length(RegStr)-1]='1')
     then RegInt:=5
     else RegInt:=StrToInt(RegStr[Length(RegStr)]);
  except
    RegInt:=1;
  end;{try .. except}
  case RegInt of
   1    : Result:='i';
   2..4 : Result:='ii';
   else   Result:='iii';
  end;{case RegInt of}
End;{Function GetName1e6(A : integer)}

Function GetName1e3(A : integer) : String;
Var
  RegStr : String;
  RegInt : integer;
Begin
  try
    RegStr:=IntToStr(A);
    if (Length(RegStr)>1)
       and (RegStr[Length(RegStr)-1]='1')
     then RegInt:=5
     else RegInt:=StrToInt(RegStr[Length(RegStr)]);
  except
    RegInt:=1;
  end;{try .. except}
  case RegInt of
   1    : Result:='';
   2..4 : Result:='i';
   else   Result:='';
  end;{case RegInt of}
End;{Function GetName1e3(A : integer)}

{************************************}
{*** Leading Zero for 01-08-1996 ****}
{************************************}
Function FirstZero(AStr    : String;
                   ALength : integer) : String;
Begin
  if Length(AStr) <= ALength
   then FirstZero := '0'+AStr
   else FirstZero := AStr;
End;{Function FirstZero}

{**************************************}
{**** Get NumToStr Under 1000 Male ****}
{**************************************}
Function Num1000(A : integer) : String;
Begin
  Result:='';
  A:=Abs(A);
  if A > 999
   then Exit;
  if A >= 100
   then Result:=Result+Hundreds[A div 100]+' ';
  if ((A mod 100) div 10 > 1)
   then Result:=Result+Tens[(A mod 100) div 10]+' ';
  if ((A mod 100) div 10) = 1 {10,11,12,...,19}
   then Result:=Result+FirstTens[(A mod 100) - 10]
   else if ((A mod 100) mod 10) <> 0
         then Result:=Result+Ones[(A mod 100) mod 10];
End;{Function Num1000(A : integer) : String;}

{****************************************}
{**** Get NumToStr Under 1000 FeMale ****}
{****************************************}
Function Num1000For1000(A : integer) : String;
Begin
  Result:='';
  A:=Abs(A);
  if A > 999
   then Exit;
  if A >= 100
   then Result:=Result+Hundreds[A div 100]+' ';
  if ((A mod 100) div 10 > 1)
   then Result:=Result+Tens[(A mod 100) div 10]+' ';
  if ((A mod 100) div 10) = 1 {10,11,12,...,19}
   then Result:=Result+FirstTens[(A mod 100) - 10]
   else if ((A mod 100) mod 10) <> 0
         then Result:=Result+OnesT[(A mod 100) mod 10];
End;{Function Num1000for1000(A : integer) : String;}


{***********************************}
{**** Quick NumToStr Procedures ****}
{***********************************}
Function NumToStrMale(A : Extended) : String;
Var
  RegStr : String;
Begin
  Result:=NumToValutaStr(A,
                         '','',
                         False,True,False);
  if Result[1]=''
   then RegStr:=''
   else RegStr:=AnsiUpperCase(Result[1]);
  Delete(Result,1,1);
  Result:=RegStr[1]+Result;
End;{Function NumToStrMale(A : integer) : String;}

Function NumToStrFemale(A : Extended) : String;
Var
  RegStr : String;
Begin
  Result:=NumToValutaStr(A,
                         '','',
                         False,True,True);
  if Result[1]=''
   then RegStr:=''
   else RegStr:=AnsiUpperCase(Result[1]);
  Delete(Result,1,1);
  Result:=RegStr[1]+Result;
End;{Function NumToStrFemale(A : integer) : String;}

{*********************************}
{**** Main NumToStr Procedure ****}
{*********************************}
Function NumToValutaStr(A            : Extended;
                        ValName      : String;
                        CentName     : String;
                        ShowCent     : Boolean;
                        CentToNumber : Boolean;
                        Female       : Boolean) : String;
Var
  Por, AInt : LongInt;
  AFrac     : integer;
Begin
  if A<0
   then Result :=' '
   else Result :='';
  AInt  := Abs(Trunc(A));
  AFrac := Abs(Round(Frac(A)*100));
  if AFrac >= 100
   then AFrac:=99;

  if AInt >= 1e9 then
   begin
     Por:=AInt div 1000000000;
     Result:=Num1000(Por)+' '+GetName1e9(Por)+' ';
   end;{if A > 1e9 then}
  if AInt >= 1e6 then
   begin
     Por:=((AInt mod 1000000000) div 1000000);
     if Por <> 0
      then Result:=Result+Num1000(Por)+
                   ' '+GetName1e6(Por)+' ';
   end;{if A > 1e6 then}
  if AInt >=1000 then
   begin
     Por:=(((AInt mod 1000000000) mod 1000000) div 1000);
     if Por <> 0
      then Result:=Result+Num1000For1000(Por)+
                   ' '+GetName1e3(Por)+' ';
   end;{if A >= 1000 then}
  if AInt > 0 then
   begin
     Por:=(((AInt mod 1000000000) mod 1000000) mod 1000);
     if Por <> 0
      then if Female
            then Result:=Result+Num1000For1000(Por)
            else Result:=Result+Num1000(Por);
     Result:=Result+' '+ValName;
   end else
   begin
     Result:=Result+'0 '+ValName;
   end;{if AInt > 0 else}

  if ShowCent then
   begin
     if AFrac > 0 then
      begin
        if CentToNumber then
         begin
           Result:=Result+' '+FirstZero(IntToStr(AFrac),1)+
                   ' '+CentName;
         end else
         begin
           Result:=Result+' '+Num1000For1000(AFrac)+
                   ' '+CentName ;
         end;{if CentToNumber else}
      end else
      begin
        Result:=Result+' 00 '+CentName;
      end;{if AFrac > 0  else}
    end;{if ShowCent then}

  Result:=Result+'.';
End;{Function NumToValutaStr}

Function NumToUAH(A : Extended) : String;
Var
  RegInt           : LongInt;
  RegStr           : String;
{  RegChar          : Char; {}
  NameVal,NameCent : String;
Begin
  RegInt := Abs(Trunc(A));
  try
    RegStr := IntToStr(RegInt);
    if (Length(RegStr) > 1)
       and (RegStr[Length(RegStr)-1] = '1') then
     begin                 {10<= A <20}
       RegInt:=5; {''}
     end else
     begin
       RegInt:=StrToInt(RegStr[Length(RegStr)]);
     end;
  except
    RegInt:=1; {''}
  end;{try .. except}

  case RegInt of
   1    : NameVal:='';
   2..4 : NameVal:='i';
   else   NameVal:='';
  end;{case RegInt of}

  RegInt := Abs(Round(Frac(A)*100));
  try
    RegStr := IntToStr(RegInt);
    if (Length(RegStr) > 1)
       and (RegStr[Length(RegStr)-1] = '1') then
     begin                 {10<= A <20}
       RegInt:=5; {'i'}
     end else
     begin
       RegInt:=StrToInt(RegStr[Length(RegStr)]);
     end;
  except
    RegInt:=1; {'i'}
  end;{try .. except}

  case RegInt of
   1    : NameCent:='i';
   2..4 : NameCent:='i';
   else   NameCent:='i';
  end;{case RegInt of}

  Result:=NumToValutaStr(A,
                         NameVal,NameCent,
                         True,True,True);

  if Result[1]=''
   then RegStr:=''
   else RegStr:=AnsiUpperCase(Result[1]);
  Delete(Result,1,1);
  Result:=RegStr[1]+Result;
End;{Function NumToUAH(A : Extended)}

Procedure DivBySpace(Source : String;
                     Len    : integer;
                     Var S1,
                         S2 : String);
Var
  i : integer;
Begin
  S1:=Source;
  S2:='';
  if (Length(Source) <= Len)
   then Exit;
  i:=Len;
  while i > 0 do
   begin
     if Source[i] = ' ' then
      begin
        S1:=Copy(Source,1,i);
        S2:=Source;
          Delete(S2,1,i);
        Exit;{Ok We Do Everything}
      end;
     Dec(i);
   end;{while i > 0 do}
  S1:='';
  S2:=Source;
End;{Procedure DivBySpace}

End{Unit AntCurr}.
