{******************************************************************************}
{**                                                                          **}
{**  Dilogs and Forms routines.                                              **}
{**                                                                          **}
{**  Author:    KARPOLAN                                                     **}
{**  E-Mail:    karpolan@yahoo.com , karpolan@utilmind.com                   **}
{**  Home Page: http://karpolan.i.am, http://www.utilmind.com                **}
{**  Copyright  1996-99 by KARPOLAN.                                        **}
{**  Copyright  1999, UtilMind Solutions.                                   **}
{**                                                                          **}
{******************************************************************************}
{**  History:                                                                **}
{**                                                                          **}
{**  31 aug 1999 - Last modified... Prepared for public release.             **}
{******************************************************************************}
Unit AntDlg;

{$Include AntUnits.Inc}

Interface

Uses
  SysUtils, Windows, Messages, Classes, Controls, StdCtrls, Forms, ExtCtrls,
  Dialogs;

{*******************************************************************************
  Centering ASlaveForm by AMasterForm
*******************************************************************************}
Procedure FormCenterForm(Const ASlaveForm, AMasterForm : TForm);

{*******************************************************************************
   Extended MessageDlg
*******************************************************************************}
Function MessageDlgEx(Const MsgStr     : String;
                      MsgDlgType       : TMsgDlgType;
                      MsgDlgButtons    : TMsgDlgButtons;
                      HelpCtx          : LongInt;
                      Const DlgCaption : String;
                      MainForm         : TForm) : Word;

{##############################################################################}
{******************************************************************************}
{##############################################################################}
Implementation
{##############################################################################}
{******************************************************************************}
{##############################################################################}


{*******************************************************************************
  Centering ASlaveForm by AMasterForm
*******************************************************************************}
Procedure FormCenterForm(Const ASlaveForm, AMasterForm : TForm);
Var
  X, Y : integer;
Begin
  if (not Assigned(AMasterForm)) or (not AMasterForm.Visible) then
   begin
     TForm(ASlaveForm).Position := poScreenCenter;
     Exit;
   end;{if not Assigned(MasterForm) then}

{** Centering ASlaveForm by AMasterForm **}
  with ASlaveForm do
   begin
     X := AMasterForm.Left + (Abs(AMasterForm.Width  - Width ) div 2);
     Y := AMasterForm.Top  + (Abs(AMasterForm.Height - Height) div 2);

     if X < 0 then X := 0;
     if Y < 0 then Y := 0;

     if (X + Width ) > Screen.Width
      then X := Screen.Width - Width;
     if (Y + Height) > Screen.Height
      then Y := Screen.Height - Height;
     Left := X;
     Top  := Y;
   end;{with ASlaveForm do}
End;{Procedure FormCenterForm}


{*******************************************************************************
   Extended MessageDlg
*******************************************************************************}
Function MessageDlgEx(Const MsgStr     : String;
                      MsgDlgType       : TMsgDlgType;
                      MsgDlgButtons    : TMsgDlgButtons;
                      HelpCtx          : LongInt;
                      Const DlgCaption : String;
                      MainForm         : TForm) : Word;
Var
  frmMessageBox : TForm;
//  i             : integer;
Begin
{** Create Message Form by Params **}
  frmMessageBox := CreateMessageDialog(MsgStr, MsgDlgType, MsgDlgButtons);
  with frmMessageBox do
   try
     HelpContext := HelpCtx;

   {** Set Caption if any income **}
     if DlgCaption <> ''
      then Caption := DlgCaption;

   {** Set 'No' button as Default if it Exists **}
     ActiveControl := TWinControl(FindComponent('No'));

(*     for i:=0 to ComponentCount-1 do
      if Components[i].Name = 'No' then
       try
         ActiveControl := TButton(Components[i]);
         Break; {** End of loop **}
       except
       end;{try..}
*)

   {** Show Form **}
     FormCenterForm(frmMessageBox, MainForm);
     Result := ShowModal;
   finally
     Free;
   end;{try..finally}
End;{Function MessageDlgEx}


END{Unit AntDlg}.
