{******************************************************************************}
{**                                                                          **}
{**  Strings and number convertion routines.                                 **}
{**                                                                          **}
{**  Author:    KARPOLAN                                                     **}
{**  E-Mail:    karpolan@yahoo.com , karpolan@utilmind.com                   **}
{**  Home Page: http://karpolan.i.am, http://www.utilmind.com                **}
{**  Copyright  1996-99 by KARPOLAN.                                        **}
{**  Copyright  1999, UtilMind Solutions.                                   **}
{**                                                                          **}
{******************************************************************************}
{**  History:                                                                **}
{**                                                                          **}
{**  31 aug 1999 - Last modified... Prepared for public release.             **}
{******************************************************************************}
Unit AntStr;

{$Include AntUnits.Inc}

Interface

{******************************************************************************}
{** Chars&Strings Routines ****************************************************}
{******************************************************************************}
Function DeleteCharFromString(AString : String;
                              AChar   : Char) : String;
Function DeleteCharsFromString(AString     : String;
                               Const Maska : String) : String;
Function LeaveCharsInString(AString     : String;
                            Const Maska : String) : String;

{******************************************************************************}
{** Numbers Convertation Routines *********************************************}
{******************************************************************************}
Function StrToExt(AString : String) : Extended;

Function ExtToStr(Value        : Extended;
                  Digit, Comma : integer) : String;

Function FirstZero(Const AString : String;
                   ALength       : integer) : String;

{##############################################################################}
{******************************************************************************}
{##############################################################################}
Implementation
{##############################################################################}
{******************************************************************************}
{##############################################################################}
Uses
  SysUtils;

{******************************************************************************}
{** Chars&Strings Routines ****************************************************}
{******************************************************************************}
Function DeleteCharFromString(AString : String;
                              AChar   : Char   ) : String;
Var
  i,k : integer;
Begin
  k := 1;
  for i:=1 to Length(AString) do
   if AString[k] = AChar
    then Delete(AString, k, 1)
    else Inc(k);
  Result := AString;
End;{Function DeleteCharFromString}

Function DeleteCharsFromString(AString     : String;
                               Const Maska : String) : String;
Var
  i : integer;
Begin
  for i:=1 to Length(Maska) do
   AString := DeleteCharFromString(AString, Maska[i]);
  Result := AString;
End;{Function DeleteCharsFromString}

Function LeaveCharsInString(AString     : String;
                            Const Maska : String) : String;
Var
  i : integer;
Begin
  Result := '';
  for i:=1 to Length(AString) do
   if Pos(AString[i], Maska) <> 0
    then Result := Result + AString[i];
End;{Function LeaveCharsInString}


{******************************************************************************}
{** Numbers Convertation Routines *********************************************}
{******************************************************************************}
Function StrToExt(AString : String) : Extended;
Var
  Code : integer;
Begin
  AString := DeleteCharFromString(AString, ThousandSeparator);
  AString := DeleteCharFromString(AString, ' ');

  Val(AString, Result, Code);
  if Code <> 0
   then Result := 0;
End;{Function StrToExt}

Function ExtToStr(Value        : Extended;
                  Digit, Comma : integer) : String;
Begin
  Str(Value:Digit:Comma, Result);
End;{Function ExtToStr}

Function FirstZero(Const AString : String;
                   ALength       : integer) : String;
Var
  i : integer;                 
Begin
//  if Length(AString) < ALength then
   for i:= 1 to (ALength - Length(AString)) do
    Result := Result + '0';

   Result := Result + AString;
End;{Function FirstZero}

END{Unit AntStr}.
