{******************************************************************************}
{**                                                                          **}
{**  Sound routine for using WAVes from resources.                           **}
{**                                                                          **}
{**  Author:    KARPOLAN                                                     **}
{**  E-Mail:    karpolan@yahoo.com , karpolan@utilmind.com                   **}
{**  Home Page: http://karpolan.i.am, http://www.utilmind.com                **}
{**  Copyright  1996-99 by KARPOLAN.                                        **}
{**  Copyright  1999, UtilMind Solutions.                                   **}
{**                                                                          **}
{******************************************************************************}
{**  History:                                                                **}
{**                                                                          **}
{**  31 aug 1999 - Last modified... Prepared for public release.             **}
{******************************************************************************}
Unit AntWav;

{$Include AntUnits.Inc}

Interface

{*******************************************************************************
   Play WAV from resource named ResName with type of resource named  ResTypeName
Wait until sound end when Wait is True and return Immediately in other case.
Don't interrupt current sound when NoStopPlay is True.
  WARNING !!! In Windows NT there are some problem with Wait = True, some times
function returns immediately without any delay.
*******************************************************************************}
Function PlayWavResource(ResName     : String;
                         ResTypeName : String;
                         Wait        : Boolean;
                         NoStopPlay  : Boolean) : Boolean;

{##############################################################################}
{******************************************************************************}
{##############################################################################}
Implementation
{##############################################################################}
{******************************************************************************}
{##############################################################################}
Uses
  Windows, MMSystem;

{*******************************************************************************
   Play WAV from resource named ResName with type of resource named  ResTypeName
Wait until sound end when Wait is True and return Immediately in other case.
Don't interrupt current sound when NoStopPlay is True.
  WARNING !!! In Windows NT there are some problem with Wait = True, some times
function returns immediately without any delay.
*******************************************************************************}
Function PlayWavResource(ResName     : String;
                         ResTypeName : String;
                         Wait        : Boolean;
                         NoStopPlay  : Boolean) : Boolean;
Var
  hRes, hResInfo  : THandle;
  lpRes           : Pointer;
  sndOptions      : Uint;
Begin
  Result := False;
{** Finding Resource **}
  hResInfo := FindResource(HInstance, PChar(ResName), PChar(ResTypeName));
  if hResInfo = Null
   then Exit;
{** Loading Resource **}
  hRes := LoadResource(HInstance, hResInfo);
  if hRes = Null
   then Exit;
{** Locking Resource **}
  lpRes := LockResource(hRes);
  if lpRes <> nil then
   begin
   {** Prepare For Playing **}
     sndOptions := (SND_Memory or SND_NoDefault);
     if Wait
      then sndOptions := (sndOptions or SND_Sync )  { Wait Until The End }
      else sndOptions := (sndOptions or SND_Async); { Return Immediately }
     if NoStopPlay
      then sndOptions := (sndOptions or SND_NoStop);{ Don't Interrupt Previous }
   {** Play Sound **}
     Result := sndPlaySound(lpRes, sndOptions);
     UnlockResource(hRes);
   end;{if .. then}
{** Free Resource **}
  FreeResource(hRes)
End;{Function PlayWavResource}


END{Unit AntWav}.
