unit Unit1;

{
----------------------------------------------------------------
THKStreams v1.5 by Harry Kakoulidis 12/1999
kcm@mailbox.gr
http://kakoulidis.homepage.com

This is Freeware. Please copy HKStrm15.zip unchanged.
If you find bugs, have options etc. Please send at my e-mail.

The use of this component is at your own risk.
I do not take any responsibility for any damages.
----------------------------------------------------------------

}


interface

uses
  HKStreamCol,Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,unit2;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    btnSave: TButton;
    btnLoad: TButton;
    edFilename: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    HKS: THKStreams;
    cbEncrypt: TCheckBox;
    cbCompress: TCheckBox;
    Label5: TLabel;
    procedure btnSaveClick(Sender: TObject);
    procedure btnLoadClick(Sender: TObject);
    function HKSAskForKey(sender: TObject): String;
    procedure cbCompressClick(Sender: TObject);
    procedure cbEncryptClick(Sender: TObject);
    procedure HKSCorrupt(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnSaveClick(Sender: TObject);
var ms : TMemoryStream;
begin
 ms:=TMemoryStream.Create;      //Create temporary MemoryStream
 try
  memo1.Lines.SaveToStream(ms); //Save memo1 to ms
  HKS.AddStream('MEMO1',ms);    //Add it to THKStreams with ID 'MEMO1'
  ms.Clear;                     //Now dont need it, so clear it
                                //Note that ID's are Case Sensitive
  memo2.Lines.SaveToStream(ms);
  HKS.AddStream('MEMO2',ms);
  ms.Clear;

  memo3.Lines.SaveToStream(ms);
  HKS.AddStream('MEMO3',ms);
  ms.Clear;

  HKS.SaveToFile(edFilename.text); //Save everything
  HKS.ClearStreams;                //Clear streams from memory
 finally
  ms.free;
 end;
 btnload.enabled:=true;
end;

procedure TForm1.btnLoadClick(Sender: TObject);
var ms : TMemoryStream;
begin
 if not fileexists(edFilename.text) then exit;
 try        // TRY becase we might be loading a corrupt file
  HKS.LoadFromFile(edFilename.text);
 except     // If the file is corrupt or user enters wrong key
            // A ECorruptFile exception is raised
            // (also the OnCorrupt is called)
  On ECorruptFile do exit;
 end;



 ms:=TMemoryStream.Create;
 try
  HKS.GetStream('MEMO3',ms);           //Get ID 'MEMO3' into MemoryStream
  memo3.Lines.LoadFromStream(ms);      //load it
  ms.clear;                            //Empty it

  HKS.GetStream('MEMO1',ms);
  memo1.Lines.LoadFromStream(ms);
  ms.clear;

  HKS.GetStream('MEMO2',ms);
  memo2.Lines.LoadFromStream(ms);
  ms.clear;
  HKS.ClearStreams;                    //Clear all streams, since we dont need them
 finally
  ms.free;                             //Destroy temporary stream
 end;
 cbcompress.Checked:=hks.Compressed;   //When we load, these are updated
 cbEncrypt.checked:=hks.Encrypted;
end;

function TForm1.HKSAskForKey(sender: TObject): String;
begin
 Form2.ShowModal;
 result:=Form2.Edit1.Text;
 // Here you could add a dialog box asking for a password
 // This is called only when you LoadFormFile and HKStreams
 // encounters a encrypted file
 // However if you want, dont assign this handler and the key that
 // will be used will be the THKStream.key
end;

procedure TForm1.HKSCorrupt(Sender: TObject);
begin
 Showmessage('Too bad! wrong password or file corrupt');
 // This message is called if the user enters a wrong password or
 // the file is messed up.
end;


procedure TForm1.cbCompressClick(Sender: TObject);
begin
 HKS.Compressed:=cbCompress.Checked;
end;

procedure TForm1.cbEncryptClick(Sender: TObject);
begin
 HKS.Encrypted:=cbEncrypt.Checked;
end;


end.


