{******************************************

  ExeComponents v1.0

  Copyright  1999 Yunus Hi-Tec Labs
  All rights reserved.

  Author: Yunus Morkramer

  These Delphi-components are free. You
  are allowed to use them without any
  qualifications.

  For questions, improvements etc. send
  us an email: info@hi-tec-labs.de

  Visit our Homepage for more components:
  www.hi-tec-labs.de

*******************************************}

unit ExeComps;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, ShellApi;

type
  TExeButton = class(TButton)
  private
    Path : TFileName;
    Param : string;
  protected
    { Protected-Deklarationen }
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  published
    property ExeName : TFileName read Path write Path;
    property Parameter : string read Param write Param;
  end;

  TExeSpeedButton = class(TSpeedButton)
  private
    Path : TFileName;
    Param : string;
  protected
    { Protected-Deklarationen }
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  published
    property ExeName : TFileName read Path write Path;
    property Parameter : string read Param write Param;
  end;

  TExeLabel = class(TLabel)
  private
    Path : TFileName;
    Param : string;
  protected
    { Protected-Deklarationen }
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  published
    property ExeName : TFileName read Path write Path;
    property Parameter : string read Param write Param;
  end;

  TExeImage = class(TImage)
  private
    Path : TFileName;
    Param : string;
  protected
    { Protected-Deklarationen }
  public
    constructor Create(AOwner: TComponent); override;
    procedure Click; override;
  published
    property ExeName : TFileName read Path write Path;
    property Parameter : string read Param write Param;
  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ExeComps', [TExeButton]);
  RegisterComponents('ExeComps', [TExeSpeedButton]);
  RegisterComponents('ExeComps', [TExeLabel]);
  RegisterComponents('ExeComps', [TExeImage]);
end;

constructor TExeButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TExeButton.Click;
var prg, param, verz: string;
begin
  prg:=ExeName+#0;
  param:=Parameter+#0;
  verz:=''+#0;
  shellexecute(Application.handle,nil,@prg[1],@param[1],@verz[1],SW_SHOW);
end;

constructor TExeSpeedButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TExeSpeedButton.Click;
var prg, param, verz: string;
begin
  prg:=ExeName+#0;
  param:=Parameter+#0;
  verz:=''+#0;
  shellexecute(Application.handle,nil,@prg[1],@param[1],@verz[1],SW_SHOW);
end;

constructor TExeLabel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Font.Color := clblue;
  Font.Style := [fsUnderline];
end;

procedure TExeLabel.Click;
var prg, param, verz: string;
begin
  prg:=ExeName+#0;
  param:=Parameter+#0;
  verz:=''+#0;
  shellexecute(Application.handle,nil,@prg[1],@param[1],@verz[1],SW_SHOW);
end;

constructor TExeImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

procedure TExeImage.Click;
var prg, param, verz: string;
begin
  prg:=ExeName+#0;
  param:=Parameter+#0;
  verz:=''+#0;
  shellexecute(Application.handle,nil,@prg[1],@param[1],@verz[1],SW_SHOW);
end;

end.

