{**********************************************************}
{ This unit was generated by IndexGen version 1.2          }
{                                                          }
{ Program......: Indexar.Pas                               }
{ Date.........: 15/09/1999 15:12:24                       }
{ Code Style...: Object Pascal for Delphi                  }
{ Purpose......: To create indexes of Tables Paradox       }
{ Idea.........: Toninho Nunes                             }
{ Written for..: Delphi 1.0x Delphi 2.0x / Delphi 3.0x     }
{                Delphi 4.0x C++ Builder.(Shortly)         }
{**********************************************************}
{ Note: Delphi 1.0x, care with the mistake line to loong   }
{ it happens for exceeding the width of the line, break    }
{ the line when this happens.                              }
{**********************************************************}
Unit Indexar;

{$T-}
interface

Uses
   { Directivas de compilao / Directive of the compilation }
   {$ifdef win32} 
     BDE, { BDE 32 BITS } 
   {$else}
     DBIProcs, DBITypes, DbiErrs, { IDAPI 16 BITS} 
   {$endif}
   Winprocs, Wintypes, Classes, SysUtils, Forms, Dialogs,
   DB, DBTables, Controls;

type
  TRIDesc = array[0..MaxInt div SizeOf(RINTDesc)-1] of RINTDesc;
  TRIOp   = array[0..MaxInt div SizeOf(CROpType)-1] of CROpType;
  TVCDesc = array[0..MaxInt div SizeOf(VCHKDesc)-1] of VCHKDesc;

{ Esta procedure  a principal / Main Procedure}
procedure Idx;
{ Deletar indices, integridades e valid checks / to delete indexes and integrities, valcheck }
procedure Del_IDX_RI(sDir : String);
{ Executar pack nas Tabelas / to execute pack in the tables }
procedure Pack_PassWord(Table: TTable; Const sPassWord : String);
{ Executar rotina de acesso ao pack / to execute routine of access to pack }
procedure PassarPack;
{ Criar integridade Refncial / to create the Referential Integrity } 
procedure CreateRI;
{ Criar Valid Checks  / To Create the Valids Checks }
procedure CreateVC;
procedure EnCodeValueCheck(const aValues : array of byte; var aValue : DBIVCHK);
{ funo para retirar brancos na string / to remove spaces of a string}
function MyTrim(S : String) : String;
function fcGetAliasPath( sAlias : String) : String;

implementation

var
  sPath : String;

procedure Idx;
var
  oTable : TTable;
  oTableList : TList;
  I : Integer;
begin
  try
    Screen.Cursor := crHourglass;

    { Fechar DataSets Abertos / Close all DataSets opened }

    oTableList := TList.Create;
    for I := Session.DatabaseCount-1 downto 0 do
      with Session.Databases[I] do
        while DatasetCount > 0 do
        begin
          oTableList.Add(Datasets[0]);
          DataSets[0].Close;
        end;

    oTable := TTable.Create(Nil);
    With oTable do begin
      DataBaseName := 'DBDEMOS';

      Exclusive := true;
      Application.ProcessMessages;


      sPath := fcGetAliasPath('DBDEMOS');


      Del_IDX_RI(sPath);

      { Criando Indice da Tabela / creating index of the table BIOLIFE.DB}
      TableName := 'BIOLIFE.DB';
      try 
        open;
        AddIndex('PrimaryKey','Species No', [ixPrimary, ixUnique ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela BIOLIFE.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table COUNTRY.DB}
      TableName := 'COUNTRY.DB';
      try 
        open;
        AddIndex('PrimaryKey','Name', [ixPrimary, ixUnique ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela COUNTRY.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table CUSTOLY.DB}
      TableName := 'CUSTOLY.DB';
      try 
        open;
        AddIndex('PrimaryKey','CustNo', [ixPrimary, ixUnique ]);
        AddIndex('City','City', []);
        AddIndex('Names','Last_Name;First_Name', [ixCaseInsensitive ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela CUSTOLY.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table CUSTOMER.DB}
      TableName := 'CUSTOMER.DB';
      try 
        open;
        AddIndex('PrimaryKey','CustNo', [ixPrimary, ixUnique ]);
        AddIndex('ByCompany','Company', [ixCaseInsensitive ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela CUSTOMER.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table EMPLOYEE.DB}
      TableName := 'EMPLOYEE.DB';
      try 
        open;
        AddIndex('PrimaryKey','EmpNo', [ixPrimary, ixUnique ]);
        AddIndex('ByName','LastName;FirstName', [ixCaseInsensitive ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela EMPLOYEE.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table EVENTS.DB}
      TableName := 'EVENTS.DB';
      try 
        open;
        AddIndex('PrimaryKey','EventNo', [ixPrimary, ixUnique ]);
        AddIndex('Date_Time','Event_Name;Event_Date', [ixCaseInsensitive ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela EVENTS.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table ITEMS.DB}
      TableName := 'ITEMS.DB';
      try 
        open;
        AddIndex('PrimaryKey','OrderNo;ItemNo', [ixPrimary, ixUnique ]);
        AddIndex('ByOrderNo','OrderNo', [ixCaseInsensitive ]);
        AddIndex('PartNo','PartNo', []);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela ITEMS.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table NEXTCUST.DB}
      TableName := 'NEXTCUST.DB';
      try 
        open;
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela NEXTCUST.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table NEXTITEM.DB}
      TableName := 'NEXTITEM.DB';
      try 
        open;
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela NEXTITEM.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table NEXTORD.DB}
      TableName := 'NEXTORD.DB';
      try 
        open;
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela NEXTORD.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table ODDATAPUMPTEST.DB}
      TableName := 'ODDATAPUMPTEST.DB';
      try 
        open;
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela ODDATAPUMPTEST.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table ORDERS.DB}
      TableName := 'ORDERS.DB';
      try 
        open;
        AddIndex('PrimaryKey','OrderNo', [ixPrimary, ixUnique ]);
        AddIndex('CustNo','CustNo', []);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela ORDERS.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table PARTS.DB}
      TableName := 'PARTS.DB';
      try 
        open;
        AddIndex('PrimaryKey','PartNo', [ixPrimary, ixUnique ]);
        AddIndex('ByDescription','Description', [ixCaseInsensitive ]);
        AddIndex('VendorNo','VendorNo', []);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela PARTS.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table RESERVAT.DB}
      TableName := 'RESERVAT.DB';
      try 
        open;
        AddIndex('PrimaryKey','ResNo', [ixPrimary, ixUnique ]);
        AddIndex('EventNo','EventNo', []);
        AddIndex('CustNo','CustNo', []);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela RESERVAT.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table VENDORS.DB}
      TableName := 'VENDORS.DB';
      try 
        open;
        AddIndex('PrimaryKey','VendorNo', [ixPrimary, ixUnique ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela VENDORS.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Criando Indice da Tabela / creating index of the table VENUES.DB}
      TableName := 'VENUES.DB';
      try 
        open;
        AddIndex('PrimaryKey','VenueNo', [ixPrimary, ixUnique ]);
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela VENUES.DB is Busy!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;
    end; { With }

    { Criar as integridades Referenciais / to Create Referential Integrity}
    CreateRI;


    { Criar os Valids Checks / To Create Valids Checks }
    CreateVC;

    { Agora vamos passar o pack nas tabelas / To Pass Pack }
    PassarPack; { acessando a rotina / Access the routine }

  finally
    oTable.Free;

    { Abrir todos DataSets do Object List / To Open All DataSets of Object TList }

    for I := oTableList.Count-1 downto 0 do
      with TDBDataset(oTableList[I]) do
      begin
        try
          Open;
          EnableControls;
          Refresh;
        except
        on E:EDataBaseError do
          showmessage(E.Message + ' - ' + TDBDataset(oTableList[I]).Name );
        end;
      end;

    Screen.Cursor := crDefault;
    oTableList.Free
  end;

end; { Fim da Procedure / End of the Procedure }

procedure PassarPack;
var
  oTable : TTable;
begin
  try
    Screen.Cursor := crHourglass;
    oTable := TTable.Create(Nil);
    With oTable do begin
      DataBaseName := 'DBDEMOS';
      Exclusive := true;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table BIOLIFE.DB}
      TableName := 'BIOLIFE.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela BIOLIFE.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table COUNTRY.DB}
      TableName := 'COUNTRY.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela COUNTRY.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table CUSTOLY.DB}
      TableName := 'CUSTOLY.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela CUSTOLY.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table CUSTOMER.DB}
      TableName := 'CUSTOMER.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela CUSTOMER.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table EMPLOYEE.DB}
      TableName := 'EMPLOYEE.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela EMPLOYEE.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table EVENTS.DB}
      TableName := 'EVENTS.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela EVENTS.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table ITEMS.DB}
      TableName := 'ITEMS.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela ITEMS.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table NEXTCUST.DB}
      TableName := 'NEXTCUST.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela NEXTCUST.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table NEXTITEM.DB}
      TableName := 'NEXTITEM.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela NEXTITEM.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table NEXTORD.DB}
      TableName := 'NEXTORD.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela NEXTORD.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table ODDATAPUMPTEST.DB}
      TableName := 'ODDATAPUMPTEST.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela ODDATAPUMPTEST.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table ORDERS.DB}
      TableName := 'ORDERS.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela ORDERS.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table PARTS.DB}
      TableName := 'PARTS.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela PARTS.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table RESERVAT.DB}
      TableName := 'RESERVAT.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela RESERVAT.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table VENDORS.DB}
      TableName := 'VENDORS.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela VENDORS.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;

      { Dar Pack na Tabela / To pass Pack in the table VENUES.DB}
      TableName := 'VENUES.DB';
      try 
        open;
        Pack_PassWord(oTable, ''); { Executar Pack na tabela / to execute the pack}
        close;
      except
        on EDatabaseError do
          MessageDlg('Tabela VENUES.DB est com problemas!',mterror, [mbok],0);
      end;
      Application.ProcessMessages;
    end; { With }
  finally
    oTable.Free;
    Screen.Cursor := crDefault;
  end; { Fim do try }
end; { Fim da Procedure }


function MyTrim(S : String) : String;
begin
  while Pos(' ', S) > 0 do 
    Delete(S, Pos(' ', S),1);
  Result := S;
end; { fim da funo / End of function }

procedure Del_IDX_RI(sDir : String);
var
  Resultado, I : Integer;
  Pesq : TSearchRec;
Const
  Extensao : array[1..4] of String =  ('.px' , '.x??' , '.y??', '.val' ); 
begin
  I := 0;
  try
    for I := 1 to 4 do begin
      Resultado := FindFirst(sDir + '*' + Extensao[I], faDirectory, Pesq);
      While Resultado = 0 do begin
        DeleteFile(sDir + Pesq.Name);
        Resultado := FindNext(Pesq);
      end; { fim do While }
    end; {fim do for} 
  finally
    FindClose(Pesq);
  end;
end; { fim da procedure / End of Procedure }

procedure Pack_PassWord(Table: TTable; Const sPassWord : String);
Var
  Props: CURProps;
  hDb: hDBIDb;
  TableDesc: CRTblDesc;
begin
  if Table.Active = False then
    raise EDatabaseError.Create('Tabela  obrigada estar aberta / It is obligatory that the table is open');
  if Table.Exclusive = False then
    raise EDatabaseError.Create('Tabela  obrigada estar em modo exclusivo / Table is forced to be in exclusive way');

  Check(DbiGetCursorProps(Table.Handle, Props));

  FillChar(TableDesc, sizeof(TableDesc), #0);
  Check(DbiGetObjFromObj(hDBIObj(Table.Handle), objDATABASE, hDBIObj(hDb)));
  With TableDesc do begin
    StrPCopy(TableDesc.szTblName, Table.TableName);
    StrPCopy(TableDesc.szTblType, Props.szTableType);

    { Verificar PassWord e adicionar / To Verify Password and to Add }

    bProtected := (sPassWord <> '');
    if bProtected then begin
      StrPCopy(szPassword, sPassWord);
      Session.AddPassword(sPassWord);
    end;
    bPack := True;
  end;
  Table.Close;
  Check(DbiDoRestructure(hDb, 1, @TableDesc, nil, nil, nil, FALSE));
end; { fim da procedure}


procedure CreateRI;
var
  TableDesc : pCRTblDesc;
  hDb : hDbiDb;
  SingleRi : ^TRIDesc;
  SingleOp : ^TRIOp;
  oTable : TTable;
begin

  {Obter DHandle }

  try
    oTable := TTable.Create(nil);
    With oTable do begin
    DataBaseName := 'DBDEMOS';
      TableName := 'ITEMS.DB';
      Open;

      { Obter o handle do objecto aqui }
      Check(DbiGetObjFromObj(hDBIObj(oTable.Handle), 
      objDATABASE, hDBIObj(hDb)));
    end;
  finally
    oTable.Free;
  end;


  try
    TableDesc := nil;
    TableDesc := AllocMem(sizeof(CRTblDesc));

    FillChar(TableDesc^, sizeOf(CRTblDesc), #0);
    With TableDesc^ do begin

      StrPCopy(szTblName, 'ITEMS.DB');
      iRintCount := 2;

      SingleOp := nil;
      SingleOp := AllocMem( iRintCount * sizeof(CROpType) );

      SingleRi := nil;
      SingleRi := AllocMem(iRintCount * sizeof(RintDesc) );

      { Agora vamos montar a integridade / Now we will set up the integrity };
      singleOp^[0] := crAdd;
      FillChar(SingleRI^[0], sizeOf(RintDesc), #0);
      With SingleRi^[0] do
      begin
        iRintNum := 1;
        StrPCopy(szRIntName,'RefOrders');
        StrPCopy(szTblName, sPath + 'ORDERS.DB');
        eType := rintDEPENDENT;
        eModOp := rintRESTRICT;
        eDelOp := rintRESTRICT;
        iFldCount := 1;
        aiThisTabFld[0] := 1;
        aiOthTabFld[0] := 1;
      end;

      { Agora vamos montar a integridade / Now we will set up the integrity };
      singleOp^[1] := crAdd;
      FillChar(SingleRI^[1], sizeOf(RintDesc), #0);
      With SingleRi^[1] do
      begin
        iRintNum := 2;
        StrPCopy(szRIntName,'CheckPartNo');
        StrPCopy(szTblName, sPath + 'PARTS.DB');
        eType := rintDEPENDENT;
        eModOp := rintRESTRICT;
        eDelOp := rintRESTRICT;
        iFldCount := 1;
        aiThisTabFld[0] := 3;
        aiOthTabFld[0] := 1;
      end;
      pecrRintOp := @singleop^;
      PrintDesc := @SingleRi^;
    end;
    Check(DbiDoRestructure(hDb, 1, tabledesc, nil, nil, nil, false));
  Finally
    FreeMem(SingleRi, (TableDesc^.iRintCount * sizeof(RintDesc)) );
    FreeMem(SingleOp, TableDesc^.iRintCount * sizeof(CROpType) );
    FreeMem(TableDesc, sizeof(CRTblDesc));
  end;


  try
    TableDesc := nil;
    TableDesc := AllocMem(sizeof(CRTblDesc));

    FillChar(TableDesc^, sizeOf(CRTblDesc), #0);
    With TableDesc^ do begin

      StrPCopy(szTblName, 'ORDERS.DB');
      iRintCount := 2;

      SingleOp := nil;
      SingleOp := AllocMem( iRintCount * sizeof(CROpType) );

      SingleRi := nil;
      SingleRi := AllocMem(iRintCount * sizeof(RintDesc) );

      { Agora vamos montar a integridade / Now we will set up the integrity };
      singleOp^[0] := crAdd;
      FillChar(SingleRI^[0], sizeOf(RintDesc), #0);
      With SingleRi^[0] do
      begin
        iRintNum := 1;
        StrPCopy(szRIntName,'RefCustinOrders');
        StrPCopy(szTblName, sPath + 'CUSTOMER.DB');
        eType := rintDEPENDENT;
        eModOp := rintRESTRICT;
        eDelOp := rintRESTRICT;
        iFldCount := 1;
        aiThisTabFld[0] := 2;
        aiOthTabFld[0] := 1;
      end;
      pecrRintOp := @singleop^;
      PrintDesc := @SingleRi^;
    end;
    Check(DbiDoRestructure(hDb, 1, tabledesc, nil, nil, nil, false));
  Finally
    FreeMem(SingleRi, (TableDesc^.iRintCount * sizeof(RintDesc)) );
    FreeMem(SingleOp, TableDesc^.iRintCount * sizeof(CROpType) );
    FreeMem(TableDesc, sizeof(CRTblDesc));
  end;


  try
    TableDesc := nil;
    TableDesc := AllocMem(sizeof(CRTblDesc));

    FillChar(TableDesc^, sizeOf(CRTblDesc), #0);
    With TableDesc^ do begin

      StrPCopy(szTblName, 'PARTS.DB');
      iRintCount := 2;

      SingleOp := nil;
      SingleOp := AllocMem( iRintCount * sizeof(CROpType) );

      SingleRi := nil;
      SingleRi := AllocMem(iRintCount * sizeof(RintDesc) );

      { Agora vamos montar a integridade / Now we will set up the integrity };
      singleOp^[0] := crAdd;
      FillChar(SingleRI^[0], sizeOf(RintDesc), #0);
      With SingleRi^[0] do
      begin
        iRintNum := 1;
        StrPCopy(szRIntName,'CheckVendor');
        StrPCopy(szTblName, sPath + 'VENDORS.DB');
        eType := rintDEPENDENT;
        eModOp := rintRESTRICT;
        eDelOp := rintRESTRICT;
        iFldCount := 1;
        aiThisTabFld[0] := 2;
        aiOthTabFld[0] := 1;
      end;
      pecrRintOp := @singleop^;
      PrintDesc := @SingleRi^;
    end;
    Check(DbiDoRestructure(hDb, 1, tabledesc, nil, nil, nil, false));
  Finally
    FreeMem(SingleRi, (TableDesc^.iRintCount * sizeof(RintDesc)) );
    FreeMem(SingleOp, TableDesc^.iRintCount * sizeof(CROpType) );
    FreeMem(TableDesc, sizeof(CRTblDesc));
  end;
end; { fim da procedure WriteRi / End of Procedure }


procedure CreateVC;
var
  TableDesc : pCRTblDesc;
  hDb : hDbiDb;
  ValCheck : ^TVCDesc;
  SingleOp : ^TRIOp;
  oTable : TTable;
begin

  {Obter DHandle }

  try
    oTable := TTable.Create(nil);
    With oTable do begin
    DataBaseName := 'DBDEMOS';
      TableName := 'ORDERS.DB';
      Open;

      { Obter o handle do objecto aqui }
      Check(DbiGetObjFromObj(hDBIObj(oTable.Handle), 
      objDATABASE, hDBIObj(hDb)));
    end;
  finally
    oTable.Free;
  end;

  try

    TableDesc := nil;
    TableDesc := AllocMem(sizeof(CRTblDesc));

    FillChar(TableDesc^, sizeOf(CRTblDesc), #0);
    With TableDesc^ do begin
      StrPCopy(szTblName, sPath + 'ORDERS.DB');
      iValChkCount := 2;

      SingleOp := nil;
      SingleOp := AllocMem( iValChkCount * sizeof(CROpType) );

      ValCheck := nil;
      ValCheck := AllocMem(iValChkCount * sizeof(VCHKDesc) );

      { Agora vamos montar os valid Checks / Now we will set up the valid Checks };

      singleOp^[0] := crAdd;
      FillChar(ValCheck^[0], sizeOf(ValCheck), #0);
      With ValCheck^[0] do
      begin
        iFldNum := 2;
        bRequired := true;
        bHasMinVal := false;
        bHasMaxVal := false;
        bHasDefVal := false;

        FillChar(aMinVal, sizeof(aMinVal), #0);
        FillChar(aMaxVal, sizeof(aMaxVal), #0);
        FillChar(aDefVal, sizeof(aDefVal), #0);

        EnCodeValueCheck([0], aMinVal) ;
        EnCodeValueCheck([0], aMaxVal) ;
        EnCodeValueCheck([0], aDefVal) ;
        szPict  := '';
      end;

      { Agora vamos montar os valid Checks / Now we will set up the valid Checks };

      singleOp^[1] := crAdd;
      FillChar(ValCheck^[1], sizeOf(ValCheck), #0);
      With ValCheck^[1] do
      begin
        iFldNum := 5;
        bRequired := true;
        bHasMinVal := false;
        bHasMaxVal := false;
        bHasDefVal := false;

        FillChar(aMinVal, sizeof(aMinVal), #0);
        FillChar(aMaxVal, sizeof(aMaxVal), #0);
        FillChar(aDefVal, sizeof(aDefVal), #0);

        EnCodeValueCheck([0,0,0,128], aMinVal) ;
        EnCodeValueCheck([0,0,0,128], aMaxVal) ;
        EnCodeValueCheck([0,0,0,128], aDefVal) ;
        szPict  := '';
      end;
      pecrValChkOp := @singleop^;
      pVChkDesc := @ValCheck^
    end;
    Check(DbiDoRestructure(hDb, 1, tabledesc, nil, nil, nil, false));
  Finally
    FreeMem(ValCheck, (TableDesc^.iValChkCount * sizeof(VCHKDesc)) );
    FreeMem(SingleOp, TableDesc^.iValChkCount * sizeof(CROpType) );
    FreeMem(TableDesc, sizeof(CRTblDesc));
  end;
end; { fim da procedure WriteVC / End of Procedure }

{ Montar valores para o valid checks / To Mount Values for valids checks }
procedure EnCodeValueCheck(const aValues : array of byte;
                            var aValue : DBIVCHK);
var
  b : Byte;
begin
  for b := Low(aValues) to High(aValues) do
    aValue[b] := aValues[b];
end;



function fcGetAliasPath( sAlias : String) : String;
var
  oAliasProp : TStringList;
  sDir : String;
begin
  try
    oAliasProp := TStringList.Create;
    Session.GetAliasParams( sAlias, oAliasProp );
    sDir := oAliasProp.Strings[0];
    if pos('PATH',sdir) <> 0 then
      System.Delete(sdir,1,5)
    else 
      sdir := '';

      Result := sDir + '\' ;
  finally
    oAliasProp.Free;
  end;
end; { fim da procedure / End of procedure }

end. { Fim da unit / End of the Unit}
