(*

  Ray Adams
  TRUrlLabel component
  (c) 1998 Ray Adams
  Allow to insert in form links in WEB style (HttP, Ftp, Mail)
  Just put your url (without HTTP or others) in caption.
  When you click on it , this component automaticaly add
  type of URL before execute it.

  Added properties:
  FActiveColor : TColor
   When mouse detected over the label
   Label text changed to this color;
  FUrlType: TUrlType;
   Setting this property you set type of
   your Url
   possible values  Http - like http://www.microsoft.com
                    Ftp,   like ftp://ftp.microsoft.com
                    Mail,  like mailto:rayadams@writeme.com
                    Custom in case of custom url type you must
                    set your type in property CustomUrlType

   FDetectMouse:Boolean;
     Inform component to change url color when mouse detected over component;
*)
unit RUrllabel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls ,ShellApi;

type
  TUrlType=(Http,Mail,Ftp,Custom);

  TRUrllabel = class(tlabel)
  private
    { Private declarations }
    FOnMouseEnter: TNotifyEvent;
    FOnMouseLeave: TNotifyEvent;
    FDetectMouse:Boolean;
    FUrlType:TUrlType;
    FCustomUrlType:string;
    FActiveColor:TColor;
    FMailSubject:String;
    procedure CMMouseEnter(var Msg:TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Msg:TMessage); message CM_MOUSELEAVE;
    procedure SetMailSubject(S:String);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create( anOwner :TComponent ); override;
    destructor Destroy; override;
    procedure Click; override;
  published
    { Published declarations }
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter
        write FOnMouseEnter;   //These show up in events
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave
        write FOnMouseLeave;
    property DetectMouse:boolean read FDetectMouse write FDetectMouse;
    Property UrlType:TUrlType read FUrlType write FUrlType default Http;
    property CustomUrlType:string read FCustomUrlType write FCustomUrlType;
    property ActiveColor:TColor read FActiveColor write FActiveColor;
    property MailSubject:String read FMailSubject write setmailsubject;
  end;

procedure Register;

implementation

procedure TRUrlLabel.CMMouseEnter(var Msg:TMessage);
begin
  if FDetectMouse then
     begin
     Font.Color:=FActiveColor;
     end;
  inherited;
  if Assigned (FOnMouseEnter) then FOnMouseEnter(Self);
end;

procedure TRUrlLabel.CMMouseLeave(var Msg:TMessage);
begin
  if FDetectMouse then
     begin
     Font.Color:=clBlue;
     end;
  inherited;
  if Assigned (FonMouseLeave) then FOnMouseLeave(Self);
end;

destructor TRUrlLabel.Destroy;
begin

 inherited Destroy;
end;

constructor TRUrlLabel.Create( anOwner :TComponent );
begin
 inherited Create( anOwner );
 Font.Color:=clBlue;
 Font.Style:=Font.style + [fsUnderline];
 Cursor:=crHandPoint;
 FDetectMouse:=true;
 ActiveColor:=clRed;

end;

procedure TRUrlLabel.Click;
var sTemp:String;
begin
case FUrlType of
Http:sTemp:='http://'+Caption;
Mail:begin
     sTemp:='mailto:'+Caption+'?Subject='+FMailSubject;
     end;
Ftp:sTemp:='ftp://'+Caption;
Custom:stemp:=FCustomUrlType+Caption;
end;
ShellExecute(GetDesktopWindow(), 'open', PChar(sTemp), nil, nil, SW_SHOWNORMAL);
end;

procedure TRUrlLabel.SetMailSubject;
begin
if FURlType<>Mail then
   begin
   Showmessage('Must be only on MAIL type');
   exit;
   end else
   begin
   FMailSubject:=S;
   end;
end;

procedure Register;
begin
  RegisterComponents('Ray Adams', [TRUrllabel]);
end;

end.
