unit janShape;

interface

uses
  Windows, WinProcs,Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs,math;


type
  TonUserDraw= procedure ( sender : Tobject) of object;
  TShapeMouseMode=(mmfixed,mmMoveObject,mmSizeObject,mmMoveText,mmRotateText);

  TFloatPoint= record
    x:extended;
    y:extended;
    end;

  TjanShapeType = (jstRectangle, jstSquare, jstRoundRect, jstRoundSquare,
    jstEllipse, jstCircle, jstValve,jstValveUp,jstHouse,
    jstTriangleRight,jstTriangleUp,jstTriangleLeft,jstTriangleDown,
    jstArrowRight,jstArrowUp,jstArrowLeft,jstArrowDown,
    jstArrowUpDown,jstArrowLeftRight,
    jstDiamond, jstOctagon,jstHexagon,jstHexagonFlat,
    jstUBarUp,jstUBarLeft,jstUBarDown,jstUBarRight,
    jstChairLeft,jstChairRight,
    jstBowlLeft,jstBowlRight,jstBowlDown,jstBowlUp,
    jstIBar,jstHBar,jst4Point,jstWaggle,
    jstCloudLeft,jstCloudRight,jstDoubleOval,jstDoubleOvalV,
    jstTorus,jstFrame,jstFrameNarrow,
    jstLBarUpLeft,jstLBarUpRight,jstLBarLeft,jstLBarRight,
    jst2HoleHoriz,jst2HoleVert,
    jstCubeUpRight,jstCubeUpLeft,jstCubeDownRight,jstCubeDownLeft,
    jstCubeHalf,jstRoofRight,jstRoofLeft,jstRoofFront,jstRoofBack,
    jstPyramid,jstMoret,jstZ,jstN,jstMatta,
    jstPistacheTop,jstPistacheBottom,jstPistacheLeft,jstPistacheRight,
    jst1Hole,jst1HoleBig,jstflower,
    jstFatArrowUp,jstFatArrowLeft,jstFatArrowDown,jstFatArrowRight,
    jstUser);
  TjanFillDirection = (jgdUp, jgdDown, jgdLeft, jgdRight,
    jgdRectOut,jgdRectIn, jgdHorizCenter, jgdVertCenter,
    jgdCircOut,jgdCircIn,jgdNWSE,jgdNESW,jgdSENW,jgdSWNE,
    jgdUright,jgdULeft,jgdUUp,jgdUDown,
    jgdRCMix,jgdRCModulo,jgdQuatro,jgdDuo,
    jgdLNE,jgdLNW,jgdUpDown,jgdLeftRight);

  TjanShape = class(TGraphicControl)
  private
    UserVector: array of TFloatPoint;
    UserPoints:integer;
    IsMouseDown:boolean;
    selObjXX:integer;
    selObjYY :integer;
    swCanvas:TCanvas;
    swleft:integer;
    swtop:integer;
    swExternal:boolean;
    FPen: TPen;
    FBrush: TBrush;
    FShape: TjanShapeType;
    FFillDirection: TjanFillDirection;
    FGradientColor: Tcolor;
    FGradient: boolean;
    FCaption: String;
    FCaptionAngle: integer;
    FCaptionY: integer;
    FCaptionX: integer;
    FCaptionCentered: boolean;
    FonUserDraw: TonUserDraw;
    FbyUser: boolean;
    FActiveMouse: boolean;
    FMouseMode: TshapeMouseMode;
    FUserVectorString: string;
    FPolyLineMode: boolean;
    FSelected: boolean;
    FGroupName: string;
    FConnectorN: string;
    FConnectorS: string;
    FConnectorW: string;
    FConnectorE: string;
    procedure SetBrush(Value: TBrush);
    procedure SetPen(Value: TPen);
    procedure SetShape(Value: TjanShapeType);
    procedure DrawTriangle;
    procedure FillWithGradient;
    procedure SetPenBrushForGradient;
    procedure SetPenBrushForOutline;
    procedure SetFillDirection(const Value: TjanFillDirection);
    procedure SetGradientColor(const Value: Tcolor);
    procedure SetGradient(const Value: boolean);
    procedure DrawArrow;
    procedure DrawUBar;
    procedure DrawChair;
    procedure DrawOctagon;
    procedure DrawEllipse;
    procedure DrawRectangle;
    procedure DrawRoundRect;
    procedure DrawValve;
    procedure DrawHouse;
    procedure DrawDiamond;
    procedure DoRectangle(fr, fg, fb, dr, dg, db: Integer);
    procedure DoHorizCenter(fr, fg, fb, dr, dg, db: Integer);
    procedure DoVertCenter(fr, fg, fb, dr, dg, db: Integer);
    procedure DrawBowl;
    procedure DrawIBar;
    procedure DrawWaggle;
    procedure DrawCloud;
    procedure DrawTorus;
    procedure DoCircle(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradNWSE(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradNESW(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradSENW(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradSWNE(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradURight(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradULeft(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradUUp(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradUDown(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradRCMix(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradRCModulo(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradQuatro(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradDuo(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradLNE(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradLNW(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradUpDown(fr, fg, fb, dr, dg, db: Integer);
    procedure doGradLeftRight(fr, fg, fb, dr, dg, db: Integer);
    procedure DrawLBar;
    procedure Draw2Hole;
    procedure SetCaption(const Value: String);
    procedure TextRotate(bitmap:tbitmap;x, y, angle: integer; atext: string;
      afont: tfont);
    procedure SetCaptionAngle(const Value: integer);
    procedure DrawText;
    procedure SetCaptionX(const Value: integer);
    procedure SetCaptionY(const Value: integer);
    procedure SetCaptionCentered(const Value: boolean);
    procedure SetonUserDraw(const Value: TonUserDraw);
    procedure DoUserDraw;
    procedure SetbyUser(const Value: boolean);
    procedure DrawHexagon;
    procedure DrawCube;
    procedure DrawRoof;
    procedure DrawPyramid;
    procedure DrawMoret;
    procedure DrawZ;
    procedure DrawMatta;
    procedure DrawPistache;
    procedure Draw1Hole;
    procedure Drawflower;
    procedure DrawFrame;
    procedure SetActiveMouse(const Value: boolean);
    procedure SetMouseMode(const Value: TshapeMouseMode);
    procedure XFillRect(R: Trect);
    procedure XPoly(P: array of TPoint);
    procedure XEllipse(x1, y1, x2, y2: integer);
    procedure XRoundrect(x1, y1, x2, y2, x3, y3: integer);
    procedure XRectangle(x1, y1, x2, y2: integer);
    procedure DrawUser;
    procedure SetUserVectorString(const Value: string);
    procedure SetPolyLineMode(const Value: boolean);
    procedure SetSelected(const Value: boolean);
    procedure SetGroupName(const Value: string);
    procedure SetConnectorN(const Value: string);
    procedure SetConnectorS(const Value: string);
    procedure SetConnectorE(const Value: string);
    procedure SetConnectorW(const Value: string);
  protected
    procedure Paint; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer);override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure PaintToCanvas(acanvas: TCanvas;Ax0,Ay0:integer;AScaleX,AscaleY:extended);
    property Canvas;

  published
    procedure StyleChanged(Sender: TObject);
    property onUserDraw: TonUserDraw read FonUserDraw write SetonUserDraw;
    property GroupName:string read FGroupName write SetGroupName;
    property ConnectorN:string read FConnectorN write SetConnectorN;
    property ConnectorS:string read FConnectorS write SetConnectorS;
    property ConnectorE:string read FConnectorE write SetConnectorE;
    property ConnectorW:string read FConnectorW write SetConnectorW;
    property UserVectorString:string read FUserVectorString write SetUserVectorString;
    property Align;
    property popupmenu;
    property Anchors;
    property Brush: TBrush read FBrush write SetBrush;
    property GradientColor:Tcolor read FGradientColor write SetGradientColor;
    property Gradient:boolean read FGradient write SetGradient default false;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Constraints;
    property ParentShowHint;
    property Pen: TPen read FPen write SetPen;
    property Shape: TjanShapeType read FShape write SetShape default jstRectangle;
    property FillDirection:TjanFillDirection read FFillDirection write SetFillDirection;
    property ShowHint;
    property Font;
    property Caption:String read FCaption write SetCaption;
    property CaptionX:integer read FCaptionX write SetCaptionX default 5;
    property CaptionY:integer read FCaptionY write SetCaptionY default 5;
    property CaptionCentered:boolean read FCaptionCentered write SetCaptionCentered;
    property CaptionAngle:integer read FCaptionAngle write SetCaptionAngle;
    property byUser:boolean read FbyUser write SetbyUser;
    property ActiveMouse:boolean read FActiveMouse write SetActiveMouse;
    property MouseMode:TshapeMouseMode read FMouseMode write SetMouseMode;
    property PolyLineMode:boolean read FPolyLineMode write SetPolyLineMode;
    property Selected:boolean read FSelected write SetSelected;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation

{ TjanShape }
uses
 janshapecontroller;

var
  X0,Y0,X, Y, W, H, S: Integer;
  w2,w3,w4,w8,w16,h2,h3,h4,h8,h16,xw,yh:integer;
  ScaleX,ScaleY:extended;
  OldLeft,OldTop,OldWidth,OldHeight:integer;

procedure Register;
begin
  RegisterComponents('Jans', [TjanShape]);
end;


constructor TjanShape.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  Width := 65;
  Height := 65;
  FPen := TPen.Create;
  FPen.OnChange := StyleChanged;
  FBrush := TBrush.Create;
  FBrush.OnChange := StyleChanged;
  FCaptionCentered:=true;
  FbyUser:=false;
  swCanvas:=Canvas;
  swExternal:=false;
  FMouseMode:=mmfixed;
  FActiveMouse:=false;
  FPolyLineMode:=false;
  FSelected:=false;
  IsMouseDown:=false;
  ScaleX:=1;
  ScaleY:=1;
  X0:=0;
  Y0:=0;
  FUserVectorString:='usrRectangle=0,0,1,0,1,1,0,1';
  UserPoints:=4;
  SetLength(UserVector,4);
  UserVector[0].x:=0;
  UserVector[0].y:=0;
  UserVector[1].x:=1;
  UserVector[1].y:=0;
  UserVector[2].x:=1;
  UserVector[2].y:=1;
  UserVector[3].x:=0;
  UserVector[3].y:=1;
end;

destructor TjanShape.Destroy;
begin
  FPen.Free;
  FBrush.Free;
  inherited Destroy;
end;

procedure TjanShape.XFillRect(R:Trect);
begin
  R.left:=x0+round(ScaleX*R.left);
  R.Right:=x0+round(ScaleX*R.right);
  R.top:=y0+round(ScaleY*R.top);
  R.bottom:=y0+round(ScaleY*R.bottom);
  swCanvas.FillRect (R);
end;

procedure TjanShape.XPoly(P:array of TPoint);
var i:integer;
begin
  for i:=0 to High(P) do
  begin
    P[i].x:=x0+round(ScaleX*P[i].x);
    P[i].y:=y0+round(ScaleY*P[i].y);
  end;
  swCanvas.Polygon (P);
end;

procedure TjanShape.XEllipse(x1,y1,x2,y2 : integer);
begin
  x1:=x0+round(ScaleX*x1);
  y1:=y0+round(ScaleY*y1);
  x2:=x0+round(ScaleX*x2);
  y2:=y0+round(ScaleY*y2);
  swCanvas.Ellipse (x1,y1,x2,y2);
end;

procedure TjanShape.XRectangle(x1,y1,x2,y2 : integer);
begin
  x1:=x0+round(ScaleX*x1);
  y1:=y0+round(ScaleY*y1);
  x2:=x0+round(ScaleX*x2);
  y2:=y0+round(ScaleY*y2);
  swCanvas.Rectangle (x1,y1,x2,y2);
end;


procedure TjanShape.XRoundrect(x1,y1,x2,y2,x3,y3 : integer);
begin
  x1:=x0+round(ScaleX*x1);
  y1:=y0+round(ScaleY*y1);
  x2:=x0+round(ScaleX*x2);
  y2:=y0+round(ScaleY*y2);
  x3:=round(ScaleX*x3);
  y3:=round(ScaleY*y3);
  swCanvas.roundrect(x1,y1,x2,y2,x3,y3);
end;


procedure TjanShape.Paint;
var
  poly: array[0..12] of TPoint;
begin
  if swExternal then
  begin
    swleft:=0;
    swtop:=0;
  end
  else
  begin
    swleft:=left;
    swtop:=top;
  end;
  with swCanvas do
  begin
    Pen := FPen;
    Brush := FBrush;
    X := Pen.Width div 2;
    Y := X;
    W := Width - Pen.Width + 1;
    H := Height - Pen.Width + 1;
    if Pen.Width = 0 then
    begin
      Dec(W);
      Dec(H);
    end;
// calcalute some often used values
    x:=round(x0+ScaleX*x);
    y:=round(y0+ScaleY*y);
    w:=round(ScaleX*w);
    h:=round(ScaleY*h);


    if W < H then S := W else S := H;
    if FShape in [jstSquare, jstRoundSquare, jstCircle] then
    begin
      Inc(X, (W - S) div 2);
      Inc(Y, (H - S) div 2);
      W := S;
      H := S;
    end;


    w2:=w div 2;
    w3:=w div 3;
    w4:=w div 4;
    w8:=w div 8;
    w16:=w div 16;
    h2:=h div 2;
    h3:=h div 3;
    h4:=h div 4;
    h8:=h div 8;
    h16:=h div 16;
    xw:=x+w-round(ScaleX*1);
    yh:=y+h-round(scaleY*1);
    case FShape of
      jstUser: DrawUser;
      jstRectangle, jstSquare: DrawRectangle;
      jstRoundRect, jstRoundSquare: DrawRoundrect;
      jstCircle, jstEllipse: DrawEllipse;
      jstValve, jstValveUp: DrawValve;
      jstHouse: DrawHouse;
      jstTriangleleft,jstTriangleRight,jstTriangleUp,jstTriangleDown: DrawTriangle;
      jstArrowRight,jstArrowLeft,jstArrowDown,jstArrowUp,jstFatArrowRight,jstFatArrowLeft,jstFatArrowDown,jstFatArrowUp: DrawArrow;
      jstDiamond: DrawDiamond;
      jstOctagon,jst4Point: DrawOctagon;
      jstHexagon,jstHexagonFlat:DrawHexagon;
      jstUBarUp,jstUBarDown,jstUBarRight,jstUBarLeft: DrawUBar;
      jstChairLeft,jstChairRight,jstArrowUpDown,jstArrowleftRight: DrawChair;
      jstBowlLeft,jstBowlRight,jstBowlDown,jstBowlUp: DrawBowl;
      jstIBar,jstHBar: DrawIBar;
      jstWaggle: DrawWaggle;
      jstCloudLeft,jstCloudRight,jstDoubleOval,jstDoubleOvalV: DrawCloud;
      jstTorus: DrawTorus;
      jstFrame,jstFrameNarrow: DrawFrame;
      jstLBarUpLeft,jstLBarUpRight,jstLBarLeft,jstLBarRight: DrawLBar;
      jst2HoleHoriz,jst2HoleVert: Draw2Hole;
      jstCubeUpRight,jstCubeUpLeft,jstCubeDownRight,
      jstCubeDownLeft,jstCubeHalf:DrawCube;
      jstRoofRight,jstRoofLeft,jstRoofFront,jstRoofBack:DrawRoof;
      jstPyramid:DrawPyramid;
      jstMoret:DrawMoret;
      jstZ,jstN:DrawZ;
      jstMatta:DrawMatta;
      jstPistacheTop,jstPistacheBottom,jstPistacheLeft,jstPistacheRight:DrawPistache;
      jst1Hole,jst1HoleBig:Draw1Hole;
      jstflower:drawflower;
    end;
   if FbyUser then
    doUserDraw
    else
    DrawText;
   if FSelected then
   begin
     canvas.Brush.color:=clred;
     canvas.pen.color:=clblack;
     canvas.Rectangle (x+w2-4,y+h2-4,x+w2+4,y+h2+4);
   end;
  end;
end;

procedure TjanShape.DrawUser;
var
   poly:array of TPoint;
   rpoly: array [0..49] of TPoint;
   rgn :Hrgn;
   i:integer;
begin
   setlength(poly,UserPoints);
   for i:=0 to UserPoints-1 do
   begin
    poly[i].x:=x+round(UserVector[i].x * (xw-x));
    poly[i].y:=y+round(UserVector[i].y * (yh-y));
   end;
    for i := 0 to UserPoints-1 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if (not FPolyLineMode) and FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,UserPoints,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else if FPolyLineMode then
     swCanvas.Polyline (poly)
   else
     swCanvas.polygon(poly);
end;

procedure TjanShape.StyleChanged(Sender: TObject);
begin
  Invalidate;

end;

procedure TjanShape.SetBrush(Value: TBrush);
begin
  FBrush.Assign(Value);
end;

procedure TjanShape.SetPen(Value: TPen);
begin
  FPen.Assign(Value);
end;

procedure TjanShape.SetShape(Value: TjanShapeType);
begin
  if FShape <> Value then
  begin
    FShape := Value;
    Invalidate;

  end;
end;

procedure TjanShape.DrawTriangle;
var
   rgn :Hrgn;
   poly: array[0..2] of TPoint;
   rpoly: array[0..2] of TPoint;
   i:integer;
begin
    case FShape of
       jstTriangleRight:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(xw,y+h2);
        poly[2]:=point(x,yh);
        end;
       jstTriangleUp:
        begin
        poly[0]:=point(x+w2,y);
        poly[1]:=point(xw,yh);
        poly[2]:=point(x,yh);
        end;
       jstTriangleLeft:
        begin
        poly[0]:=point(xw,y);
        poly[1]:=point(xw,yh);
        poly[2]:=point(x,y+h2);
        end;
       jstTriangleDown:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(xw,y);
        poly[2]:=point(x+w2,yh);
        end;
       end;
    for i := 0 to 2 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,3,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(slice(poly,3));
   end
   else
   swCanvas.polygon(slice(poly,3));
end;

procedure TjanShape.DrawArrow;
var
   rgn :Hrgn;
   poly: array[0..6] of TPoint;
   rpoly: array[0..6] of TPoint;
   i:integer;

begin
    case FShape of
       jstArrowRight:
        begin
        poly[0]:=point(x,y+(h div 2)-(h div 16));
        poly[1]:=point(x+w-1-(w div 4),y+(h div 2)-(h div 16));
        poly[2]:=point(x+w-1-(w div 4),y);
        poly[3]:=point(x+w-1,y+(h div 2));
        poly[4]:=point(x+w-1-(w div 4),y+h-1);
        poly[5]:=point(x+w-1-(w div 4),y+(h div 2)+(h div 16));
        poly[6]:=point(x,y+(h div 2)+(h div 16));
        end;
       jstArrowLeft:
        begin
        poly[0]:=point(x+w-1,y+(h div 2)-(h div 16));
        poly[1]:=point(x+(w div 4),y+(h div 2)-(h div 16));
        poly[2]:=point(x+(w div 4),y);
        poly[3]:=point(x,y+(h div 2));
        poly[4]:=point(x+(w div 4),y+h-1);
        poly[5]:=point(x+(w div 4),y+(h div 2)+(h div 16));
        poly[6]:=point(x+w-1,y+(h div 2)+(h div 16));
        end;
       jstArrowUp:
        begin
        poly[0]:=point(x+(w div 2)-(w div 16),y+h-1);
        poly[1]:=point(x+(w div 2)-(w div 16),y+(h div 4));
        poly[2]:=point(x,y+(h div 4));
        poly[3]:=point(x+(w div 2),y);
        poly[4]:=point(x+w-1,y+(h div 4));
        poly[5]:=point(x+(w div 2)+(w div 16),y+(h div 4));
        poly[6]:=point(x+(w div 2)+(w div 16),y+h-1);
        end;
       jstArrowDown:
        begin
        poly[0]:=point(x+(w div 2)-(w div 16),y);
        poly[1]:=point(x+(w div 2)-(w div 16),y+h-1-(h div 4));
        poly[2]:=point(x,y+h-1-(h div 4));
        poly[3]:=point(x+(w div 2),y+h-1);
        poly[4]:=point(x+w-1,y+h-1-(h div 4));
        poly[5]:=point(x+(w div 2)+(w div 16),y+h-1-(h div 4));
        poly[6]:=point(x+(w div 2)+(w div 16),y);
        end;
       jstFatArrowRight:
        begin
        poly[0]:=point(x,y+h8);
        poly[1]:=point(xw-w8,y+h8);
        poly[2]:=point(xw-w8,y);
        poly[3]:=point(xw,y+h2);
        poly[4]:=point(xw-w8,yh);
        poly[5]:=point(xw-w8,yh-h8);
        poly[6]:=point(x,yh-h8);
        end;
       jstFatArrowLeft:
        begin
        poly[0]:=point(xw,y+h8);
        poly[1]:=point(x+w8,y+h8);
        poly[2]:=point(x+w8,y);
        poly[3]:=point(x,y+h2);
        poly[4]:=point(x+w8,yh);
        poly[5]:=point(x+w8,yh-h8);
        poly[6]:=point(xw,yh-h8);
        end;
       jstFatArrowUp:
        begin
        poly[0]:=point(x+w8,yh);
        poly[1]:=point(x+w8,y+h8);
        poly[2]:=point(x,y+h8);
        poly[3]:=point(x+w2,y);
        poly[4]:=point(xw,y+h8);
        poly[5]:=point(xw-w8,y+h8);
        poly[6]:=point(xw-w8,yh);
        end;
       jstFatArrowDown:
        begin
        poly[0]:=point(x+w8,y);
        poly[1]:=point(x+w8,yh-h8);
        poly[2]:=point(x,yh-h8);
        poly[3]:=point(x+w2,yh);
        poly[4]:=point(xw,yh-h8);
        poly[5]:=point(xw-w8,yh-h8);
        poly[6]:=point(xw-w8,y);
        end;
       end;
    for i := 0 to 6 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,7,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawChair;
var
   rgn :Hrgn;
   poly: array[0..9] of TPoint;
   rpoly: array[0..9] of TPoint;
   i:integer;
begin
    case FShape of
       jstChairLeft:
        begin
        poly[0]:=point(xw,y);
        poly[1]:=point(xw-w4,y);
        poly[2]:=point(xw-w4,y+h2);
        poly[3]:=point(x,y+h2);
        poly[4]:=point(x,yh);
        poly[5]:=point(x+w4,yh);
        poly[6]:=point(x+w4,yh-h4);
        poly[7]:=point(xw-w4,yh-h4);
        poly[8]:=point(xw-w4,yh);
        poly[9]:=point(xw,yh);
        end;
       jstChairRight:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x+w4,y);
        poly[2]:=point(x+w4,y+h2);
        poly[3]:=point(xw,y+h2);
        poly[4]:=point(xw,yh);
        poly[5]:=point(xw-w4,yh);
        poly[6]:=point(xw-w4,yh-h4);
        poly[7]:=point(x+w4,yh-h4);
        poly[8]:=point(x+w4,yh);
        poly[9]:=point(x,yh);
        end;
       jstArrowUpDown:
        begin
        poly[0]:=point(x+w2,y);
        poly[1]:=point(x,y+h8);
        poly[2]:=point(x+w8,y+h8);
        poly[3]:=point(x+w8,yh-h8);
        poly[4]:=point(x,yh-h8);
        poly[5]:=point(x+w2,yh);
        poly[6]:=point(xw,yh-h8);
        poly[7]:=point(xw-w8,yh-h8);
        poly[8]:=point(xw-w8,y+h8);
        poly[9]:=point(xw,y+h8);
        end;
       jstArrowleftRight:
        begin
        poly[0]:=point(x,y+h2);
        poly[1]:=point(x+w8,yh);
        poly[2]:=point(x+w8,yh-h8);
        poly[3]:=point(xw-w8,yh-h8);
        poly[4]:=point(xw-w8,yh);
        poly[5]:=point(xw,y+h2);
        poly[6]:=point(xw-w8,y);
        poly[7]:=point(xw-w8,y+h8);
        poly[8]:=point(x+w8,y+h8);
        poly[9]:=point(x+w8,y);
        end;
       end;
    for i := 0 to 9 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,10,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawValve;
var
   rgn :Hrgn;
   poly: array[0..3] of TPoint;
   rpoly: array[0..3] of TPoint;
   i:integer;
begin
    case FShape of
      jstValve:
        begin
         poly[0]:=point(x,y);
         poly[1]:=point(xw,yh);
         poly[2]:=point(xw,y);
         poly[3]:=point(x,yh);
        end;
      jstValveUp:
        begin
         poly[0]:=point(x,y);
         poly[1]:=point(xw,y);
         poly[2]:=point(x,yh);
         poly[3]:=point(xw,yh);
        end;
       end;
    for i := 0 to 3 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,4,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;


procedure TjanShape.DrawOctagon;
var
   rgn :Hrgn;
   poly: array[0..7] of TPoint;
   rpoly: array[0..7] of TPoint;
   i:integer;
begin
    case FShape of
       jstOctagon:
        begin
        poly[0]:=point(x+(w div 3),y);
        poly[1]:=point(x+w-1-(w div 3),y);
        poly[2]:=point(x+w-1,y+(h div 3));
        poly[3]:=point(x+w-1,y+h-1-(h div 3));
        poly[4]:=point(x+w-1-(w div 3),y+h-1);
        poly[5]:=point(x+(w div 3),y+h-1);
        poly[6]:=point(x,y+h-1-(h div 3));
        poly[7]:=point(x,y+(h div 3));
        end;
       jst4Point:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x+w2,y+h4);
        poly[2]:=point(xw,y);
        poly[3]:=point(xw-w4,y+h2);
        poly[4]:=point(xw,yh);
        poly[5]:=point(x+w2,yh-h4);
        poly[6]:=point(x,yh);
        poly[7]:=point(x+w4,y+h2);
        end;
       end;
    for i := 0 to 7 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,8,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawCube;
var
   rgn :Hrgn;
   poly: array[0..11] of TPoint;
   rpoly: array[0..5] of TPoint;
   i:integer;
begin
    case FShape of
       jstCubeUpRight:
        begin
        poly[0]:=point(x,yh);
        poly[1]:=point(xw-w3,yh);
        poly[2]:=point(xw,yh-h3);
        poly[3]:=point(xw,y);
        poly[4]:=point(x+w3,y);
        poly[5]:=point(x,y+h3);
        end;
       jstCubeHalf:
        begin
        poly[0]:=point(x,yh);
        poly[1]:=point(xw-w3,yh);
        poly[2]:=point(xw,yh-h3);
        poly[3]:=point(xw,yh-h3-h3);
        poly[4]:=point(x+w3,yh-h3-h3);
        poly[5]:=point(x,yh-h3);
        end;
       jstCubeUpLeft:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh-h3);
        poly[2]:=point(x+w3,yh);
        poly[3]:=point(xw,yh);
        poly[4]:=point(xw,y+h3);
        poly[5]:=point(xw-w3,y);
        end;
       jstCubeDownLeft:
        begin
        poly[0]:=point(x,y+h3);
        poly[1]:=point(x,yh);
        poly[2]:=point(xw-w3,yh);
        poly[3]:=point(xw,yh-h3);
        poly[4]:=point(xw,y);
        poly[5]:=point(x+w3,y);
        end;
       jstCubeDownRight:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh-h3);
        poly[2]:=point(x+w3,yh);
        poly[3]:=point(xw,yh);
        poly[4]:=point(xw,y+h3);
        poly[5]:=point(xw-w3,y);
        end;
       end;
    for i := 0 to 5 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,6,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   end;
    case FShape of
       jstCubeUpRight:
        begin
        poly[0]:=point(xw-w3,y+h3);
        poly[1]:=point(x,y+h3);
        poly[2]:=point(x,yh);
        poly[3]:=point(xw-w3,yh);
        poly[4]:=point(xw-w3,y+h3);
        poly[5]:=point(xw,y);
        poly[6]:=point(xw,yh-h3);
        poly[7]:=point(xw-w3,yh);
        poly[8]:=point(xw-w3,y+h3);
        poly[9]:=point(x,y+h3);
        poly[10]:=point(x+w3,y);
        poly[11]:=point(xw,y);
        end;
       jstCubeHalf:
        begin
        poly[0]:=point(xw-w3,yh-h3);
        poly[1]:=point(x,yh-h3);
        poly[2]:=point(x,yh);
        poly[3]:=point(xw-w3,yh);
        poly[4]:=point(xw-w3,yh-h3);
        poly[5]:=point(xw,yh-h3-h3);
        poly[6]:=point(xw,yh-h3);
        poly[7]:=point(xw-w3,yh);
        poly[8]:=point(xw-w3,yh-h3);
        poly[9]:=point(x,yh-h3);
        poly[10]:=point(x+w3,yh-h3-h3);
        poly[11]:=point(xw,yh-h3-h3);
        end;
       jstCubeUpLeft:
        begin
        poly[0]:=point(x+w3,y+h3);
        poly[1]:=point(xw,y+h3);
        poly[2]:=point(xw,yh);
        poly[3]:=point(x+w3,yh);
        poly[4]:=point(x+w3,y+h3);
        poly[5]:=point(x,y);
        poly[6]:=point(x,yh-h3);
        poly[7]:=point(x+w3,yh);
        poly[8]:=point(x+w3,y+h3);
        poly[9]:=point(xw,y+h3);
        poly[10]:=point(xw-w3,y);
        poly[11]:=point(x,y);
        end;
       jstCubeDownLeft:
        begin
        poly[0]:=point(x+w3,yh-h3);
        poly[1]:=point(xw,yh-h3);
        poly[2]:=point(xw,y);
        poly[3]:=point(x+w3,y);
        poly[4]:=point(x+w3,yh-h3);
        poly[5]:=point(x+w3,y);
        poly[6]:=point(x,y+h3);
        poly[7]:=point(x,yh);
        poly[8]:=point(x+w3,yh-h3);
        poly[9]:=point(xw,yh-h3);
        poly[10]:=point(xw-w3,yh);
        poly[11]:=point(x,yh);
        end;
       jstCubeDownRight:
        begin
        poly[0]:=point(xw-w3,yh-h3);
        poly[1]:=point(x,yh-h3);
        poly[2]:=point(x,y);
        poly[3]:=point(xw-w3,y);
        poly[4]:=point(xw-w3,yh-h3);
        poly[5]:=point(xw-w3,y);
        poly[6]:=point(xw,y+h3);
        poly[7]:=point(xw,yh);
        poly[8]:=point(xw-w3,yh-h3);
        poly[9]:=point(x,yh-h3);
        poly[10]:=point(x+w3,yh);
        poly[11]:=point(xw,yh);
        end;
       end;
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawRoof;
var
   rgn :Hrgn;
   poly: array[0..6] of TPoint;
   rpoly: array[0..4] of TPoint;
   i:integer;
begin
    case FShape of
       jstRoofFront:
        begin
        poly[0]:=point(x,yh);
        poly[1]:=point(xw-w3,yh);
        poly[2]:=point(xw,yh-h3);
        poly[3]:=point(xw,y);
        poly[4]:=point(x+w3,y);
        end;
       jstRoofBack:
        begin
        poly[0]:=point(x,yh);
        poly[1]:=point(xw-w3,yh);
        poly[2]:=point(xw,yh-h3);
        poly[3]:=point(xw-w3,y);
        poly[4]:=point(x,y);
        end;
       jstRoofLeft:
        begin
        poly[0]:=point(x,y+h3);
        poly[1]:=point(x,yh);
        poly[2]:=point(xw-w3,yh);
        poly[3]:=point(xw,yh-h3);
        poly[4]:=point(x+w3,y);
        end;
       jstRoofRight:
        begin
        poly[0]:=point(x,yh);
        poly[1]:=point(xw-w3,yh);
        poly[2]:=point(xw,yh-h3);
        poly[3]:=point(xw,y);
        poly[4]:=point(xw-w3,y+h3);
        end;
       end;
    for i := 0 to 4 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,5,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   end;
    case FShape of
       jstRoofFront:
        begin
        poly[0]:=point(xw-w3,yh);
        poly[1]:=point(xw,y);
        poly[2]:=point(x+w3,y);
        poly[3]:=point(x,yh);
        poly[4]:=point(xw-w3,yh);
        poly[5]:=point(xw,yh-h3);
        poly[6]:=point(xw,y);
        end;
       jstRoofBack:
        begin
        poly[0]:=point(xw-w3,yh);
        poly[1]:=point(xw-w3,y);
        poly[2]:=point(x,y);
        poly[3]:=point(x,yh);
        poly[4]:=point(xw-w3,yh);
        poly[5]:=point(xw,yh-h3);
        poly[6]:=point(xw-w3,y);
        end;
       jstRoofLeft:
        begin
        poly[0]:=point(x,y+h3);
        poly[1]:=point(x,yh);
        poly[2]:=point(xw-w3,yh);
        poly[3]:=point(x,y+h3);
        poly[4]:=point(x+w3,y);
        poly[5]:=point(xw,yh-h3);
        poly[6]:=point(xw-w3,yh);
        end;
       jstRoofRight:
        begin
        poly[0]:=point(xw-w3,yh);
        poly[1]:=point(xw-w3,y+h3);
        poly[2]:=point(x,yh);
        poly[3]:=point(xw-w3,yh);
        poly[4]:=point(xw,yh-h3);
        poly[5]:=point(xw,y);
        poly[6]:=point(xw-w3,y+h3);
        end;
       end;
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawPyramid;
var
   rgn :Hrgn;
   poly: array[0..5] of TPoint;
   rpoly: array[0..3] of TPoint;
   i:integer;
begin
    case FShape of
       jstPyramid:
        begin
        poly[0]:=point(x,yh);
        poly[1]:=point(xw-w3,yh);
        poly[2]:=point(xw,yh-h3);
        poly[3]:=point(x+w2,y);
        end;
       end;
    for i := 0 to 3 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,4,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   end;
    case FShape of
       jstPyramid:
        begin
        poly[0]:=point(xw-w3,yh);
        poly[1]:=point(x+w2,y);
        poly[2]:=point(x,yh);
        poly[3]:=point(xw-w3,yh);
        poly[4]:=point(xw,yh-h3);
        poly[5]:=point(x+w2,y);
        end;
       end;
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawMoret;
var
   rgn :Hrgn;
   poly: array[0..19] of TPoint;
   rpoly: array[0..19] of TPoint;
   i:integer;
begin
    case FShape of
       jstMoret:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,y+h4);
        poly[2]:=point(x+w8,y+h4);
        poly[3]:=point(x+w8,yh-h4);
        poly[4]:=point(x,yh-h4);
        poly[5]:=point(x,yh);
        poly[6]:=point(x+w4,yh);
        poly[7]:=point(x+w4,yh-h8);
        poly[8]:=point(xw-w4,yh-h8);
        poly[9]:=point(xw-w4,yh);
        poly[10]:=point(xw,yh);
        poly[11]:=point(xw,yh-h4);
        poly[12]:=point(xw-w8,yh-h4);
        poly[13]:=point(xw-w8,y+h4);
        poly[14]:=point(xw,y+h4);
        poly[15]:=point(xw,y);
        poly[16]:=point(xw-w4,y);
        poly[17]:=point(xw-w4,y+h8);
        poly[18]:=point(x+w4,y+h8);
        poly[19]:=point(x+w4,y);
        end;
       end;
    for i := 0 to 19 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,20,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   end;
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawZ;
var
   rgn :Hrgn;
   poly: array[0..9] of TPoint;
   rpoly: array[0..9] of TPoint;
   i:integer;
begin
    case FShape of
       jstZ:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,y+h4);
        poly[2]:=point(xw-w3,y+h4);
        poly[3]:=point(x,yh-h4);
        poly[4]:=point(x,yh);
        poly[5]:=point(xw,yh);
        poly[6]:=point(xw,yh-h4);
        poly[7]:=point(x+w3,yh-h4);
        poly[8]:=point(xw,y+h4);
        poly[9]:=point(xw,y);
        end;
       jstN:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh);
        poly[2]:=point(x+w4,yh);
        poly[3]:=point(x+w4,y+h3);
        poly[4]:=point(xw-w4,yh);
        poly[5]:=point(xw,yh);
        poly[6]:=point(xw,y);
        poly[7]:=point(xw-w4,y);
        poly[8]:=point(xw-w4,yh-h3);
        poly[9]:=point(x+w4,y);
        end;

       end;
    for i := 0 to 9 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,10,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   end;
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawMatta;
var
   rgn :Hrgn;
   poly: array[0..15] of TPoint;
   rpoly: array[0..15] of TPoint;
   i:integer;
begin
    case FShape of
       jstMatta:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,y+h4);
        poly[2]:=point(x+w2,y+h2);
        poly[3]:=point(x,yh-h4);
        poly[4]:=point(x,yh);
        poly[5]:=point(x+w4,yh);
        poly[6]:=point(x+w2,y+h2);
        poly[7]:=point(xw-w4,yh);
        poly[8]:=point(xw,yh);
        poly[9]:=point(xw,yh-h4);
        poly[10]:=point(x+w2,y+h2);
        poly[11]:=point(xw,y+h4);
        poly[12]:=point(xw,y);
        poly[13]:=point(xw-w4,y);
        poly[14]:=point(x+w2,y+h2);
        poly[15]:=point(x+w4,y);
        end;
       end;
    for i := 0 to 15 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,16,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   end;
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawHexagon;
var
   rgn :Hrgn;
   poly: array[0..5] of TPoint;
   rpoly: array[0..5] of TPoint;
   i:integer;
begin
    case FShape of
       jstHexagon:
        begin
        poly[0]:=point(x+w2,y);
        poly[1]:=point(xw,y+h4);
        poly[2]:=point(xw,yh-h4);
        poly[3]:=point(x+w2,yh);
        poly[4]:=point(x,yh-h4);
        poly[5]:=point(x,y+h4);
        end;
       jstHexagonFlat:
        begin
        poly[0]:=point(x+w4,y);
        poly[1]:=point(xw-w4,y);
        poly[2]:=point(xw,y+h2);
        poly[3]:=point(xw-w4,yh);
        poly[4]:=point(x+w4,yh);
        poly[5]:=point(x,y+h2);
        end;
       end;
    for i := 0 to 5 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,6,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;


procedure TjanShape.DrawWaggle;
var
   rgn :Hrgn;
   poly: array[0..15] of TPoint;
   rpoly: array[0..15] of TPoint;
   i:integer;
begin
    case FShape of
       jstWaggle:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x+w4,y+h8);
        poly[2]:=point(x+w2,y);
        poly[3]:=point(xw-w4,y+h8);
        poly[4]:=point(xw,y);
        poly[5]:=point(xw-w8,y+h4);
        poly[6]:=point(xw,y+h2);
        poly[7]:=point(xw-w8,yh-h4);
        poly[8]:=point(xw,yh);
        poly[9]:=point(xw-w4,yh-h8);
        poly[10]:=point(x+w2,yh);
        poly[11]:=point(x+w4,yh-h8);
        poly[12]:=point(x,yh);
        poly[13]:=point(x+w8,yh-h4);
        poly[14]:=point(x,y+h2);
        poly[15]:=point(x+w8,y+h4);
        end;
       end;
    for i := 0 to 15 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,16,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawHouse;
var
   rgn :Hrgn;
   poly: array[0..4] of TPoint;
   rpoly: array[0..4] of TPoint;
   i:integer;
begin
    case FShape of
       jstHouse:
        begin
         poly[0]:=point(x+w2,y);
         poly[1]:=point(xw,y+h2);
         poly[2]:=point(xw,yh);
         poly[3]:=point(x,yh);
         poly[4]:=point(x,y+h2);
        end;
       end;
    for i := 0 to 4 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,5,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawDiamond;
var
   rgn :Hrgn;
   poly: array[0..3] of TPoint;
   rpoly: array[0..3] of TPoint;
   i:integer;
begin
    case FShape of
       jstDiamond:
        begin
        poly[0]:=point(x+(w div 2),y);
        poly[1]:=point(x+w-1,y+(h div 2));
        poly[2]:=point(x+(w div 2),y+h-1);
        poly[3]:=point(x,y+(h div 2));
        end;
       end;
    for i := 0 to 3 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,4,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;


procedure TjanShape.DrawEllipse;
var
   rgn :Hrgn;
begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      SelectClipRgn(swCanvas.handle,rgn);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn);
     SetPenBrushForOutLine;
     swCanvas.Ellipse(X, Y, X + W, Y + H);
   end
   else
     swCanvas.Ellipse(X, Y, X + W, Y + H);
end;

procedure TjanShape.DrawBowl;
var
   rgn0,rgn1,rgn2 :Hrgn;
begin
   case FShape of
//       jstBowlLeft: Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
//       jstBowlRight: Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
//       jstBowlDown: Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
//       jstBowlUp: Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);

   jstBowlLeft:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn2 := CreateRectRgn(swleft+x,swtop+Y,swleft+x+w2,swtop+Y+H);
      combineRgn(rgn0,rgn1,rgn2,RGN_AND);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
   end
   else
     swCanvas.Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
   end;
   jstBowlRight:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn2 := CreateRectRgn(swleft+x+w2,swtop+Y,swleft+x+W,swtop+Y+H);
      combineRgn(rgn0,rgn1,rgn2,RGN_AND);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
   end
   else
     swCanvas.Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
   end;
   jstBowlUp:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn2 := CreateRectRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H2);
      combineRgn(rgn0,rgn1,rgn2,RGN_AND);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);
   end
   else
     swCanvas.Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);
   end;
   jstBowlDown:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn2 := CreateRectRgn(swleft+x,swtop+Y+h2,swleft+x+W,swtop+Y+H);
      combineRgn(rgn0,rgn1,rgn2,RGN_AND);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
   end
   else
     swCanvas.Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
   end;

  end;
end;

procedure TjanShape.DrawCloud;
var
   rgn0,rgn1,rgn2 :Hrgn;
begin
   case FShape of
//       jstBowlLeft: Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
//       jstBowlRight: Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
//       jstBowlDown: Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
//       jstBowlUp: Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);

   jstCloudLeft:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xw-W4,swtop+Yh-h4);
      rgn2 := CreateEllipticRgn(swleft+x+w4,swtop+Y+h4,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw-w4,yh-h4);
     swCanvas.ellipse(x+w4,y+h4,xw,yh);
   end
   else begin
     swCanvas.ellipse(x,y,xw-w4,yh-h4);
     swCanvas.ellipse(x+w4,y+h4,xw,yh);
     end;
   end;
   jstDoubleOval:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+w2,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x+w2,swtop+Y,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,x+w2,yh);
     swCanvas.ellipse(x+w2,y,xw,yh);
   end
   else begin
     swCanvas.ellipse(x,y,x+w2,yh);
     swCanvas.ellipse(x+w2,y,xw,yh);
     end;
   end;
   jstDoubleOvalV:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xw,swtop+Y+h2);
      rgn2 := CreateEllipticRgn(swleft+x,swtop+Y+h2,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,y+h2);
     swCanvas.ellipse(x,y+h2,xw,yh);
   end
   else begin
     swCanvas.ellipse(x,y,xw,y+h2);
     swCanvas.ellipse(x,y+h2,xw,yh);
     end;
   end;
   jstCloudRight:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x+w4,swtop+Y,swleft+xw,swtop+Yh-h4);
      rgn2 := CreateEllipticRgn(swleft+x,swtop+Y+h4,swleft+xW-w4,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x+w4,y,xw,yh-h4);
     swCanvas.ellipse(x,y+h4,xw-w4,yh);
   end
   else begin
     swCanvas.ellipse(x+w4,y,xw,yh-h4);
     swCanvas.ellipse(x,y+h4,xw-w4,yh);
     end;
   end;
   end;
end;

procedure TjanShape.DrawPistache;
var
   rgn0,rgn1,rgn2 :Hrgn;
begin
   case FShape of
   jstPistacheTop:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x,swtop+Y+h2,swleft+xw,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x,y+h2,xw,yh);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x,y+h2,xw,yh);
     end;
   end;
   jstPistacheBottom:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x,swtop+Y,swleft+xw,swtop+Y+h2);
      rgn2 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x,y,xw,y+h2);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x,y,xw,y+h2);
     end;
   end;
   jstPistacheLeft:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x+w2,swtop+Y,swleft+xw,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x+w2,y,xw,yh);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x+w2,y,xw,yh);
     end;
   end;
   jstPistacheRight:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x,swtop+Y,swleft+x+w2,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xW,swtop+YH);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x,y,x+w2,yh);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.rectangle(x,y,x+w2,yh);
     end;
   end;
   end;
end;

procedure TjanShape.Draw1Hole;
var
   rgn0,rgn1,rgn2 :Hrgn;
begin
   case FShape of
   jst1Hole:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x,swtop+Y,swleft+xw,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x+w4,swtop+Y+h4,swleft+xW-w4,swtop+YH-h4);
      combineRgn(rgn0,rgn1,rgn2,RGN_XOR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.rectangle(x,y,xw,yh);
     swCanvas.ellipse(x+w4,y+h4,xw-w4,yh-h4);
   end
   else begin
     swCanvas.rectangle(x,y,xw,yh);
     swCanvas.ellipse(x+w4,y+h4,xw-w4,yh-h4);
     end;
   end;
   jst1HoleBig:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x,swtop+Y,swleft+xw,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x+w8,swtop+Y+h8,swleft+xW-w8,swtop+YH-h8);
      combineRgn(rgn0,rgn1,rgn2,RGN_XOR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.rectangle(x,y,xw,yh);
     swCanvas.ellipse(x+w8,y+h8,xw-w8,yh-h8);
   end
   else begin
     swCanvas.rectangle(x,y,xw,yh);
     swCanvas.ellipse(x+w8,y+h8,xw-w8,yh-h8);
     end;
   end;
   end;
end;


procedure TjanShape.Draw2Hole;
var
   rgn0,rgn1,rgn2,rgn3,rgn4 :Hrgn;
begin
   case FShape of
//       jstBowlLeft: Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
//       jstBowlRight: Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
//       jstBowlDown: Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
//       jstBowlUp: Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);

   jst2HoleHoriz:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+Xw,swtop+YH);
      rgn2 := CreateEllipticRgn(swleft+x+w8,swtop+Y+h4,swleft+x+w2-w8,swtop+YH-h4);
      combineRgn(rgn0,rgn1,rgn2,RGN_XOR);
      rgn4 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn3 := CreateEllipticRgn(swleft+x+w2+w8,swtop+Y+h4,swleft+xw-w8,swtop+YH-h4);
      combineRgn(rgn4,rgn0,rgn3,RGN_XOR);
      SelectClipRgn(swCanvas.handle,rgn4);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn4);
      DeleteObject(rgn3);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.ellipse(x+w8,y+h4,x+w2-w8,yh-h4);
     swCanvas.ellipse(x+w2+w8,y+h4,xw-w8,yh-h4);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.ellipse(x+w8,y+h4,x+w2-w8,yh-h4);
     swCanvas.ellipse(x+w2+w8,y+h4,xw-w8,yh-h4);
     end;
   end;
   jst2HoleVert:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+Xw,swtop+YH);
      rgn2 := CreateEllipticRgn(swleft+x+w4,swtop+Y+h8,swleft+xw-w4,swtop+Y+h2-h8);
      combineRgn(rgn0,rgn1,rgn2,RGN_XOR);
      rgn4 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn3 := CreateEllipticRgn(swleft+x+w4,swtop+Y+h2+h8,swleft+xw-w4,swtop+YH-h8);
      combineRgn(rgn4,rgn0,rgn3,RGN_XOR);
      SelectClipRgn(swCanvas.handle,rgn4);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn4);
      DeleteObject(rgn3);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.ellipse(x+w4,y+h8,xw-w4,y+h2-h8);
     swCanvas.ellipse(x+w4,y+h2+h8,xw-w4,yh-h8);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.ellipse(x+w4,y+h8,xw-w4,y+h2-h8);
     swCanvas.ellipse(x+w4,y+h2+h8,xw-w4,yh-h8);
     end;
   end;
   end;
end;

procedure TjanShape.Drawflower;
var
   rgn0,rgn1,rgn2,rgn3,rgn4 :Hrgn;
begin
   case FShape of
   jstflower:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y+h3,swleft+x+w2,swtop+YH-h3);
      rgn2 := CreateEllipticRgn(swleft+x+w3,swtop+Y,swleft+x+xw-w3,swtop+Y+h2);
      rgn3 := CreateEllipticRgn(swleft+x+w2,swtop+Y+h3,swleft+xw,swtop+YH-h3);
      rgn4 := CreateEllipticRgn(swleft+x+w3,swtop+Y+h2,swleft+xw-w3,swtop+Y+H);
      combineRgn(rgn0,rgn1,rgn2,RGN_OR);
      combineRgn(rgn0,rgn0,rgn3,RGN_OR);
      combineRgn(rgn0,rgn0,rgn4,RGN_OR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn4);
      DeleteObject(rgn3);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y+h3,x+w2,yh-h3);
     swCanvas.ellipse(x+w3,y,xw-w3,y+h2);
     swCanvas.ellipse(x+w2,y+h3,xw,yh-h3);
     swCanvas.ellipse(x+w3,y+h2,xw-w3,yh);
   end
   else begin
     swCanvas.ellipse(x,y+h3,x+w2,yh-h3);
     swCanvas.ellipse(x+w3,y,xw-w3,y+h2);
     swCanvas.ellipse(x+w2,y+h3,xw,yh-h3);
     swCanvas.ellipse(x+w3,y+h2,xw-w3,yh);
     end;
   end;
  end;
end;


procedure TjanShape.DrawTorus;
var
   rgn0,rgn1,rgn2 :Hrgn;
begin
   case FShape of
//       jstBowlLeft: Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
//       jstBowlRight: Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
//       jstBowlDown: Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
//       jstBowlUp: Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);

   jstTorus:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateEllipticRgn(swleft+x,swtop+Y,swleft+xw,swtop+Yh);
      rgn2 := CreateEllipticRgn(swleft+x+w4,swtop+Y+h4,swleft+xW-w4,swtop+YH-h4);
      combineRgn(rgn0,rgn1,rgn2,RGN_XOR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.ellipse(x+w4,y+h4,xw-w4,yh-h4);
   end
   else begin
     swCanvas.ellipse(x,y,xw,yh);
     swCanvas.ellipse(x+w4,y+h4,xw-w4,yh-h4);
     end;
   end;
   end;
end;

procedure TjanShape.DrawFrame;
var
   rgn0,rgn1,rgn2 :Hrgn;
   dw,dh:integer;
begin
   case Fshape of
    jstFrame: begin dw:=w4;dh:=h4;end;
    jstFrameNarrow: begin dw:=w8;dh:=h8;end;
    end;
   case FShape of
//       jstBowlLeft: Pie(x,y,x+w,y+h,x+w2,y,x+w2,y+h);
//       jstBowlRight: Pie(x,y,x+w,y+h,x+w2,y+h,x+w2,y);
//       jstBowlDown: Pie(x,y,x+w,y+h,x,y+h2,x+w,y+h2);
//       jstBowlUp: Pie(x,y,x+w,y+h,x+w,y+h2,x,y+h2);

   jstFrame,jstFrameNarrow:
   begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn0 := CreateRectRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      rgn1 := CreateRectRgn(swleft+x,swtop+Y,swleft+xw,swtop+Yh);
      rgn2 := CreateRectRgn(swleft+x+dw,swtop+Y+dh,swleft+xW-dw,swtop+YH-dh);
      combineRgn(rgn0,rgn1,rgn2,RGN_XOR);
      SelectClipRgn(swCanvas.handle,rgn0);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn2);
      DeleteObject(rgn1);
      DeleteObject(rgn0);
     SetPenBrushForOutLine;
     swCanvas.rectangle(x,y,xw,yh);
     swCanvas.rectangle(x+dw,y+dh,xw-dw,yh-dh);
   end
   else begin
     swCanvas.rectangle(x,y,xw,yh);
     swCanvas.rectangle(x+dw,y+dh,xw-dw,yh-dh);
     end;
   end;
   end;
end;

procedure TjanShape.DrawRectangle;
var
   rgn :Hrgn;
begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn := CreateRectRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H);
      SelectClipRgn(swCanvas.handle,rgn);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn);
     SetPenBrushForOutLine;
     swCanvas.Rectangle(X, Y, X + W, Y + H);
   end
   else
     swCanvas.Rectangle(X, Y, X + W, Y + H);
end;

procedure TjanShape.DrawRoundRect;
var
   rgn :Hrgn;
begin
   if FGradient then begin
      SetPenBrushForGradient;
      rgn := CreateRoundRectRgn(swleft+x,swtop+Y,swleft+x+W,swtop+Y+H,S div 4, S div 4);
      SelectClipRgn(swCanvas.handle,rgn);
      FillWithGradient;
      SelectClipRgn(swCanvas.handle,0);
      DeleteObject(rgn);
     SetPenBrushForOutLine;
     swCanvas.RoundRect(X, Y, X + W, Y + H, S div 4, S div 4);
   end
   else
     swCanvas.RoundRect(X, Y, X + W, Y + H, S div 4, S div 4);
end;


procedure TjanShape.DrawUBar;
var
   rgn :Hrgn;
   poly: array[0..7] of TPoint;
   rpoly: array[0..7] of TPoint;
   i:integer;
begin
    case FShape of
       jstUBarUp:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh);
        poly[2]:=point(xw,yh);
        poly[3]:=point(xw,y);
        poly[4]:=point(xw-w4,y);
        poly[5]:=point(xw-w4,yh-h4);
        poly[6]:=point(x+w4,yh-h4);
        poly[7]:=point(x+w4,y);
        end;
       jstUBarLeft:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(xw,y);
        poly[2]:=point(xw,yh);
        poly[3]:=point(x,yh);
        poly[4]:=point(x,yh-h4);
        poly[5]:=point(xw-w4,yh-h4);
        poly[6]:=point(xw-w4,y+h4);
        poly[7]:=point(x,y+h4);
        end;
       jstUBarDown:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh);
        poly[2]:=point(x+w4,yh);
        poly[3]:=point(x+w4,y+h4);
        poly[4]:=point(xw-w4,y+h4);
        poly[5]:=point(xw-w4,yh);
        poly[6]:=point(xw,yh);
        poly[7]:=point(xw,y);
        end;
       jstUBarRight:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh);
        poly[2]:=point(xw,yh);
        poly[3]:=point(xw,yh-h4);
        poly[4]:=point(x+w4,yh-h4);
        poly[5]:=point(x+w4,y+h4);
        poly[6]:=point(xw,y+h4);
        poly[7]:=point(xw,y);
        end;
       end;
    for i := 0 to 7 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,8,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawIBar;
var
   rgn :Hrgn;
   poly: array[0..11] of TPoint;
   rpoly: array[0..11] of TPoint;
   i:integer;
begin
    case FShape of
       jstIBar:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(xw,y);
        poly[2]:=point(xw,y+h4);
        poly[3]:=point(xw-w4,y+h4);
        poly[4]:=point(xw-w4,yh-h4);
        poly[5]:=point(xw,yh-h4);
        poly[6]:=point(xw,yh);
        poly[7]:=point(x,yh);
        poly[8]:=point(x,yh-h4);
        poly[9]:=point(x+w4,yh-h4);
        poly[10]:=point(x+w4,y+h4);
        poly[11]:=point(x,y+h4);
        end;
       jstHBar:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x+w4,y);
        poly[2]:=point(x+w4,y+h4);
        poly[3]:=point(xw-h4,y+h4);
        poly[4]:=point(xw-h4,y);
        poly[5]:=point(xw,y);
        poly[6]:=point(xw,yh);
        poly[7]:=point(xw-w4,yh);
        poly[8]:=point(xw-w4,yh-h4);
        poly[9]:=point(x+w4,yh-h4);
        poly[10]:=point(x+w4,yh);
        poly[11]:=point(x,yh);
        end;
       end;
    for i := 0 to 11 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,12,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;

procedure TjanShape.DrawLBar;
var
   rgn :Hrgn;
   poly: array[0..5] of TPoint;
   rpoly: array[0..5] of TPoint;
   i:integer;
begin
    case FShape of
       jstLBarLeft:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(x,yh);
        poly[2]:=point(xw,yh);
        poly[3]:=point(xw,yh-h4);
        poly[4]:=point(x+w4,yh-h4);
        poly[5]:=point(x+w4,y);
        end;
       jstLBarRight:
        begin
        poly[0]:=point(xw,y);
        poly[1]:=point(xw,yh);
        poly[2]:=point(x,yh);
        poly[3]:=point(x,yh-h4);
        poly[4]:=point(xw-h4,yh-h4);
        poly[5]:=point(xw-h4,y);
        end;
       jstLBarUpLeft:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(xw,y);
        poly[2]:=point(xw,y+h4);
        poly[3]:=point(x+w4,y+h4);
        poly[4]:=point(x+w4,yh);
        poly[5]:=point(x,yh);
        end;
       jstLBarUpRight:
        begin
        poly[0]:=point(x,y);
        poly[1]:=point(xw,y);
        poly[2]:=point(xw,yh);
        poly[3]:=point(xw-h4,yh);
        poly[4]:=point(xw-h4,y+h4);
        poly[5]:=point(x,y+h4);
        end;
       end;
    for i := 0 to 5 do
    begin
       rpoly[i].x := swleft+poly[i].x;
       rpoly[i].y := swtop+poly[i].y;
    end;
   if FGradient then begin
   SetPenBrushForGradient;
   rgn :=  Winprocs.CreatePolygonRgn(rpoly,6,WINDING);
   SelectClipRgn(swCanvas.handle,rgn);
   FillWithGradient;
   SelectClipRgn(swCanvas.handle,0);
   DeleteObject(rgn);
   SetPenBrushForOutLine;
   swCanvas.polygon(poly);
   end
   else
   swCanvas.polygon(poly);
end;


procedure TjanShape.FillWithGradient;
var
  TargetRect : TRect;
  i         : Integer;
  clrFrom,clrTo : TColor;
  RGBFromR,RGBFromG,RGBFromB : Byte;
  RGBDiffR,RGBDiffG,RGBDiffB : integer;

begin
   clrFrom := FGradientColor;
   clrTo := FGradientColor;

   Case FFillDirection of
   jgdUp: clrFrom := FBrush.Color;
   jgdDown: clrTo := FBrush.Color;
   jgdLeft: clrFrom := FBrush.Color;
   jgdRight: clrTo := FBrush.Color;
   jgdRectOut: clrTo:=FBrush.color;
   jgdRectIn:clrFrom:=FBrush.color;
   jgdCircOut: clrTo:=FBrush.color;
   jgdCircIn:clrFrom:=FBrush.color;
   jgdHorizCenter:clrFrom:=FBrush.color;
   jgdVertCenter:clrFrom:=FBrush.color;
   jgdNWSE,jgdNESW,jgdSENW,jgdSWNE:clrFrom:=FBrush.color;
   jgdUright,jgdULeft,jgdUUp,jgdUDown:clrFrom:=FBrush.color;
   jgdDuo,jgdQuatro,jgdRCMix,jgdRCModulo:clrFrom:=FBrush.color;
   jgdLNE,jgdLNW,jgdUpDown,jgdLeftRight:clrFrom:=FBrush.color;
   end;

   RGBFromR := GetRValue (ColorToRGB (ClrFrom));
   RGBFromG := GetGValue (ColorToRGB (ClrFrom));
   RGBFromB := GetBValue (ColorToRGB (ClrFrom));
   RGBDiffR := GetRValue (ColorToRGB (ClrTo)) - RGBFromR;
   RGBDiffG := GetGValue (ColorToRGB (ClrTo)) - RGBFromG;
   RGBDiffB := GetBValue (ColorToRGB (ClrTo)) - RGBFromB;

   swCanvas.Pen.Style := psSolid;
   swCanvas.Pen.Mode := pmCopy;
   swCanvas.Brush.style:=bssolid;
   case FFillDirection of
    jgdLeft,jgdRight:
     begin
     for i := 0 to 255 do
     begin
         TargetRect := Rect(MulDiv (i,Width,256),0,
                            MulDiv (i+1,Width,256),Height);
         swCanvas.Brush.Color := RGB (RGBFromR + MulDiv(i,RGBDiffR, 255),
                                    RGBFromG + MulDiv(i,RGBDiffG, 255),
                                    RGBFromB + MulDiv(i,RGBDiffB, 255));

//         swCanvas.FillRect (TargetRect);
     XFillRect(Targetrect);
     end;
    end; {if left or right}
    jgdUp,jgdDown:
    begin
     for i := 0 to $ff do
     begin
         TargetRect := Rect(0,MulDiv (i,Height,256),
                            Width,MulDiv (i+1,Height,256));
         swCanvas.Brush.Color := RGB (RGBFromR + MulDiv(i,RGBDiffR,255),
                                    RGBFromG + MulDiv(i,RGBDiffG,255),
                                    RGBFromB + MulDiv(i,RGBDiffB,255));
//         swCanvas.FillRect (TargetRect);
        XFillRect(TargetRect);
     end;
   end;
   jgdRectOut,jgdRectIn: DoRectangle(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdCircOut,jgdCircIn: DoCircle(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdHorizCenter: DoHorizCenter(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdVertCenter: DoVertCenter(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdNWSE: doGradNWSE(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdNESW: doGradNESW(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdSENW: doGradSENW(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdSWNE: doGradSWNE(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdURight: doGradURight(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdLNE: doGradLNE(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdLNW: doGradLNW(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdULeft: doGradULeft(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdUUp: doGradUUp(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdUDown: doGradUDown(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdRCMix: doGradRCMix(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdRCModulo: doGradRCModulo(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdQuatro: doGradQuatro(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdDuo:doGradDuo(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdUpDown:doGradUpDown(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);
   jgdLeftRight:doGradLeftRight(
     RGBFromR,RGBFromG,RGBFromB,RGBDiffR,RGBDiffG,RGBDiffB);

  end;
end;

procedure TjanShape.DoRectangle(fr, fg, fb, dr, dg, db : Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw, Ph : Real;
  x1,y1,x2,y2 : Real;
  gra:Trect;
begin
  swCanvas.Pen.Style := psClear;
  swCanvas.Pen.Mode := pmCopy;
  x1 := 0;
  x2 := Width+2;
  y1 := 0;
  y2 := Height+2;
  Pw := (Width / 2) / 255;
  Ph := (Height / 2) / 255;
  for I := 0 to 255 do begin         //Make rectangles of color
    x1 := x1 + Pw;
    x2 := X2 - Pw;
    y1 := y1 + Ph;
    y2 := y2 - Ph;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    gra:=Rect(Trunc(x1),Trunc(y1),Trunc(x2),Trunc(y2));
//    swCanvas.FillRect(gra);
    XFillrect(gra);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.DoCircle(fr, fg, fb, dr, dg, db : Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw, Ph : Real;
  x1,y1,x2,y2 : Real;
begin
  swCanvas.Pen.Style := psClear;
  swCanvas.Pen.Mode := pmCopy;
  x1 := 0;
  x2 := Width+2;
  y1 := 0;
  y2 := Height+2;
  Pw := (Width / 2) / 255;
  Ph := (Height / 2) / 255;
  for I := 0 to 255 do begin         //Make cicles of color
    x1 := x1 + Pw;
    x2 := X2 - Pw;
    y1 := y1 + Ph;
    y2 := y2 - Ph;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
//    swCanvas.Ellipse(Trunc(x1),Trunc(y1),Trunc(x2),Trunc(y2));
    XEllipse(Trunc(x1),Trunc(y1),Trunc(x2),Trunc(y2));
  end;
  swCanvas.Pen.Style := psSolid;
end;


procedure TjanShape.DoVertCenter(fr, fg, fb, dr, dg, db : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
  Haf : Integer;
begin
  Haf := Height Div 2;
  ColorRect.Left := 0;
  ColorRect.Right := Width;
  for I := 0 to Haf do begin
    ColorRect.Top := MulDiv (I, Haf, Haf);
    ColorRect.Bottom := MulDiv (I + 1, Haf, Haf);
    R := fr + MulDiv(I, dr, Haf);
    G := fg + MulDiv(I, dg, Haf);
    B := fb + MulDiv(I, db, Haf);
    swCanvas.Brush.Color := RGB(R, G, B);
//    swCanvas.FillRect(ColorRect);
    XFillRect(Colorrect);
    ColorRect.Top := Height - (MulDiv (I, Haf, Haf));
    ColorRect.Bottom := Height - (MulDiv (I + 1, Haf, Haf));
//    swCanvas.FillRect(ColorRect);
    XFillRect(ColorRect);
  end;
end;

procedure TjanShape.DoHorizCenter(fr, fg, fb, dr, dg, db : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
  Haf : Integer;
begin
  Haf := Width Div 2;
  ColorRect.Top := 0;
  ColorRect.Bottom := Height;
  for I := 0 to Haf do begin
    ColorRect.Left := MulDiv (I, Haf, Haf);
    ColorRect.Right := MulDiv (I + 1, Haf, Haf);
    R := fr + MulDiv(I, dr, Haf);
    G := fg + MulDiv(I, dg, Haf);
    B := fb + MulDiv(I, db, Haf);
    swCanvas.Brush.Color := RGB(R, G, B);
//    swCanvas.FillRect(ColorRect);
    XFillRect(ColorRect);
    ColorRect.Left := Width - (MulDiv (I, Haf, Haf));
    ColorRect.Right := Width - (MulDiv (I + 1, Haf, Haf));
//    swCanvas.FillRect(ColorRect);
    XFillRect(ColorRect);
  end;
end;



procedure TjanShape.SetPenBrushForGradient;
begin
     swCanvas.Brush.style := bsSolid;
end;

procedure TjanShape.SetPenBrushForOutline;
begin
    swCanvas.Brush.style := bsClear;
    swCanvas.pen.color := FPen.color;
    swCanvas.pen.width := FPen.Width ;
    swCanvas.pen.style := FPen.Style ;
end;


procedure TjanShape.SetFillDirection(const Value: TjanFillDirection);
begin
  if Value <> FFillDirection then
  begin
    FFillDirection := Value;
    Refresh;
  end;
end;

procedure TjanShape.SetGradientColor(const Value: Tcolor);
begin
  if Value <> FGradientColor then
  begin
    FGradientColor := Value;
    Refresh;
  end;

end;

procedure TjanShape.SetGradient(const Value: boolean);
begin
  if Value <> FGradient then
  begin
    FGradient := Value;
    Refresh;
  end;
end;

procedure TjanShape.SetCaption(const Value: String);
begin
  if FCaption <> Value then
  begin
    FCaption := Value;
    Invalidate;
  end;
end;

procedure TjanShape.TextRotate(bitmap:tbitmap;x, y, angle: integer; atext: string;
  afont: tfont);
var dc:hdc;
    fnt:LogFont;
    plf:PLogFont;
    hfnt,hfntPrev:hfont;
    i:integer;
    fname,s:string;
begin
s:=atext;
fnt.lfEscapement :=angle*10;
fnt.lfOrientation :=angle*10;
if fsbold in afont.Style  then
  fnt.lfWeight :=FW_Bold
  else
  fnt.lfWeight :=FW_NORMAL;
if fsitalic in afont.style then
  fnt.lfItalic :=1
  else
  fnt.lfItalic :=0;
if fsunderline in afont.style then
  fnt.lfUnderline :=1
  else
  fnt.lfUnderline :=0;
fnt.lfStrikeOut :=0;
fnt.lfHeight :=abs(afont.Height);
fname:=afont.Name ;
for i:=1 to length(fname) do
  fnt.lffacename[i-1]:=fname[i];
fnt.lfFaceName [length(fname)]:=#0;
hfnt := CreateFontIndirect(fnt);
dc:=bitmap.Canvas.handle;
SetBkMode(dc, TRANSPARENT);
SetTextColor(dc,afont.color);
hfntPrev := SelectObject(dc, hfnt);
//textout(dc,x,y,@atext[1],length(atext));
textout(dc,x,y,@s[1],length(s));
SelectObject(dc, hfntPrev);
DeleteObject(hfnt);
end;


procedure TjanShape.SetCaptionAngle(const Value: integer);
begin
  if FCaptionAngle <> Value then
  begin
    FCaptionAngle := Value;
    Invalidate;

  end;
end;

procedure TjanShape.DrawText;
var
    bm:Tbitmap;
    fx,fy,fw,fh:integer;
begin
    bm:=tbitmap.create;
    bm.width:=round(scaleX*width);
    bm.height:=round(scaleY*height);
    bm.Canvas.font.assign(font);
    bm.canvas.font.Height :=round(ScaleY*bm.canvas.font.height);
    fw:=bm.Canvas.TextWidth (FCaption);
    fh:=bm.Canvas.TextHeight (FCaption);
    if fw>xw then
      fx:=5
      else
      fx:=(round(ScaleX*width)-fw) div 2;
    if fh>yh then
      fy:=5
      else
      fy:=(round(ScaleY*height)-fh) div 2;
    if FCaptionCentered then
    textrotate(bm,fx,fy,FCaptionAngle,FCaption,bm.canvas.font)
    else
    textrotate(bm,round(ScaleX*FCaptionX),round(scaleY*FCaptionY),FCaptionAngle,FCaption,bm.canvas.font);
   bm.transparent:=true;
   bm.TransparentMode :=tmfixed;
   bm.TransparentColor :=clwhite;
   swCanvas.Draw (x0,y0,bm);
   bm.free;
end;

procedure TjanShape.SetCaptionX(const Value: integer);
begin
  if FCaptionX <> Value then
  begin
    FCaptionX := Value;
    Invalidate;
  end;

end;

procedure TjanShape.SetCaptionY(const Value: integer);
begin
  if FCaptionY <> Value then
  begin
    FCaptionY := Value;
    Invalidate;
  end;

end;

procedure TjanShape.SetCaptionCentered(const Value: boolean);
begin
  if FCaptionCentered <> Value then
  begin
    FCaptionCentered := Value;
    Invalidate;
  end;
end;

procedure TjanShape.SetonUserDraw(const Value: TonUserDraw);
begin
  FonUserDraw := Value;
end;

procedure TjanShape.DoUserDraw;
begin
  if assigned (FonUserDraw) then
    FonUserDraw(self);

end;


procedure TjanShape.SetbyUser(const Value: boolean);
begin
  if FbyUser <> Value then
  begin
    FbyUser := Value;
    Invalidate;
  end;

end;

procedure TjanShape.doGradNWSE(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw: Real;
  x0,y0,x1,y1,x2,y2,x3,y3 : Real;
  points:array[0..3] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Pw := (Width+height) / 255;
  for I := 0 to 254 do begin         //Make trapeziums of color
    x0 := i*Pw;
    if (x0<width) then y0:=0 else
      begin
      y0:=x0-width;
      x0:=width-1;
      end;
    x1:=(i+1)*pw;
    if (x1<width) then begin
      y1:=0;
      end
      else begin
      y1:=x1-width;
      x1:=width-1;
      end;
    y2:=i*pw;
    if (y2<height) then x2:=0 else
      begin
      x2:=y2-height;
      y2:=height-1;
      end;
    y3:=(i+1)*pw;
    if (y3<height) then x3:=0 else
      begin
      x3:=y3-height;
      y3:=height-1;
      end;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(x0),Trunc(y0));
    points[1]:=point(Trunc(x1),Trunc(y1));
    points[3]:=point(Trunc(x2),Trunc(y2));
    points[2]:=point(Trunc(x3),Trunc(y3));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradNESW(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw: Real;
  x0,y0,x1,y1,x2,y2,x3,y3 : Real;
  points:array[0..3] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Pw := (Width+height) / 255;
  for I := 0 to 254 do begin         //Make trapeziums of color
    y0 := i*Pw;
    if (y0<height) then x0:=width-1 else
      begin
      x0:=width-1-(y0-height);
      y0:=height-1;
      end;
    y1:=(i+1)*pw;
    if (y1<height) then x1:=width-1 else
      begin
      x1:=width-1-(y1-height);
      x1:=width-1;
      end;
    x2:=width-1-(i*pw);
    if (x2>0) then y2:=0 else
      begin
      y2:=-x2;
      x2:=0;
      end;
    x3:=width-1-((i+1)*pw);
    if (x3>0) then y3:=0 else
      begin
      y3:=-x3;
      x3:=0;
      end;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(x0),Trunc(y0));
    points[1]:=point(Trunc(x1),Trunc(y1));
    points[3]:=point(Trunc(x2),Trunc(y2));
    points[2]:=point(Trunc(x3),Trunc(y3));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradSENW(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw: Real;
  x0,y0,x1,y1,x2,y2,x3,y3 : Real;
  points:array[0..3] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Pw := (Width+height) / 255;
  for I := 0 to 254 do begin         //Make trapeziums of color
    y0 := height-1-(i*Pw);
    if (y0>0) then x0:=width-1 else
      begin
      x0:=width-1+y0;
      y0:=0;
      end;
    y1:=height-1-((i+1)*pw);
    if (y1>0) then x1:=width-1 else
      begin
      x1:=width-1+y1;
      y1:=0;
      end;
    x2:=width-1-(i*pw);
    if (x2>0) then y2:=height-1 else
      begin
      y2:=height-1+x2;
      x2:=0;
      end;
    x3:=width-1-((i+1)*pw);
    if (x3>0) then y3:=height-1 else
      begin
      y3:=height-1+x3;
      x3:=0;
      end;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(x0),Trunc(y0));
    points[1]:=point(Trunc(x1),Trunc(y1));
    points[3]:=point(Trunc(x2),Trunc(y2));
    points[2]:=point(Trunc(x3),Trunc(y3));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradSWNE(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw: Real;
  x0,y0,x1,y1,x2,y2,x3,y3 : Real;
  points:array[0..3] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Pw := (Width+height) / 255;
  for I := 0 to 254 do begin         //Make trapeziums of color
    y0 := height-1-(i*Pw);
    if (y0>0) then x0:=0 else
      begin
      x0:=-y0;
      y0:=0;
      end;
    y1:=height-1-((i+1)*pw);
    if (y1>0) then x1:=0 else
      begin
      x1:=-y1;
      y1:=0;
      end;
    x2:=(i*pw);
    if (x2<width) then y2:=height-1 else
      begin
      y2:=height-1-(x2-width);
      x2:=width-1;
      end;
    x3:=(i+1)*pw;
    if (x3<width) then y3:=height-1 else
      begin
      y3:=height-1-(x3-width);
      x3:=width-1;
      end;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(x0),Trunc(y0));
    points[1]:=point(Trunc(x1),Trunc(y1));
    points[3]:=point(Trunc(x2),Trunc(y2));
    points[2]:=point(Trunc(x3),Trunc(y3));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradURight(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  points:array[0..7] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := (height/2) / 255;
  pw:=width/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(width-1),Trunc(i*ph));
    points[1]:=point(Trunc(i*pw),Trunc(i*ph));
    points[2]:=point(Trunc(i*pw),Trunc(height-1-i*ph));
    points[3]:=point(Trunc(width-1),Trunc(height-1-i*ph));
    points[4]:=point(Trunc(width-1),Trunc(height-1-i*ph-ph));
    points[5]:=point(Trunc(i*pw+pw),Trunc(height-1-i*ph-ph));
    points[6]:=point(Trunc(i*pw+pw),Trunc(i*ph+ph));
    points[7]:=point(Trunc(width-1),Trunc(i*ph+ph));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradULeft(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  points:array[0..7] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := (height/2) / 255;
  pw:=width/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(0),Trunc(i*ph));
    points[1]:=point(Trunc(width-1-i*pw),Trunc(i*ph));
    points[2]:=point(Trunc(width-1-i*pw),Trunc(height-1-i*ph));
    points[3]:=point(Trunc(0),Trunc(height-1-i*ph));
    points[4]:=point(Trunc(0),Trunc(height-1-i*ph-ph));
    points[5]:=point(Trunc(width-1-i*pw-pw),Trunc(height-1-i*ph-ph));
    points[6]:=point(Trunc(width-1-i*pw-pw),Trunc(i*ph+ph));
    points[7]:=point(Trunc(0),Trunc(i*ph+ph));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradUDown(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  points:array[0..7] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := height / 255;
  pw:=width/2/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(i*pw),Trunc(height-1));
    points[1]:=point(Trunc(i*pw),Trunc(i*ph));
    points[2]:=point(Trunc(width-1-i*pw),Trunc(i*ph));
    points[3]:=point(Trunc(width-1-i*pw),Trunc(height-1));
    points[4]:=point(Trunc(width-1-i*pw-pw),Trunc(height-1));
    points[5]:=point(Trunc(width-1-i*pw-pw),Trunc(i*ph+ph));
    points[6]:=point(Trunc(i*pw+pw),Trunc(i*ph+ph));
    points[7]:=point(Trunc(i*pw+pw),Trunc(height-1));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradUUp(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  points:array[0..7] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := height / 255;
  pw:=width/2/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(i*pw),Trunc(0));
    points[1]:=point(Trunc(i*pw),Trunc(height-1-i*ph));
    points[2]:=point(Trunc(width-1-i*pw),Trunc(height-1-i*ph));
    points[3]:=point(Trunc(width-1-i*pw),Trunc(0));
    points[4]:=point(Trunc(width-1-i*pw-pw),Trunc(0));
    points[5]:=point(Trunc(width-1-i*pw-pw),Trunc(height-1-i*ph-ph));
    points[6]:=point(Trunc(i*pw+pw),Trunc(height-1-i*ph-ph));
    points[7]:=point(Trunc(i*pw+pw),Trunc(0));
//    swCanvas.polygon(points);
    XPoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradRCMix(fr, fg, fb, dr, dg, db: Integer);
var
  I,x3,y3: Integer;
  R, G, B : Byte;
  Pw,ph: Real;

begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := (height/2) / 255;
  pw:=(width/2)/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
     x3:=trunc(width-2*i*pw) div 4;
     y3:=trunc(height-2*i*ph) div 4;
    if i=0 then begin x3:=0;y3:=0 end;
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    if i<63 then
    Xroundrect(trunc(i*pw),trunc(i*ph),
     trunc(width-i*pw),trunc(height-1-i*ph),
     x3,y3)
    else
    Xellipse(trunc(i*pw),trunc(i*ph),
     trunc(width-i*pw),trunc(height-1-i*ph));
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradRCModulo(fr, fg, fb, dr, dg, db: Integer);
var
  I,x3,y3: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  IsRect:boolean;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := (height/2) / 255;
  pw:=(width/2)/255;
  IsRect:=false;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
     x3:=trunc(width-2*i*pw) div 4;
     y3:=trunc(height-2*i*ph) div 4;
    if i=0 then begin x3:=0;y3:=0 end;
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    if (i mod 10)=0 then IsRect:= not IsRect;
    if IsRect then
    Xroundrect(trunc(i*pw),trunc(i*ph),
     trunc(width-i*pw),trunc(height-1-i*ph),
     x3,y3)
    else
    Xellipse(trunc(i*pw),trunc(i*ph),
     trunc(width-i*pw),trunc(height-1-i*ph));
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradQuatro(fr, fg, fb, dr, dg, db: Integer);
var
  I,w2,h2: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := (height/4) / 255;
  pw:=(width/4)/255;
  w2:=width div 2;
  h2:=height div 2;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    Xrectangle(trunc(i*pw),trunc(i*ph),
     trunc(w2+1-i*pw),trunc(h2+1-i*ph));
    Xrectangle(trunc(w2-1+i*pw),trunc(i*ph),
     trunc(width-1-i*pw),trunc(h2+1-i*ph));
    Xrectangle(trunc(i*pw),trunc(h2-1+i*ph),
     trunc(w2+1-i*pw),trunc(height-1-i*ph));
    Xrectangle(trunc(w2-1+i*pw),trunc(h2-1+i*ph),
     trunc(width-1-i*pw),trunc(height-1-i*ph));
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradDuo(fr, fg, fb, dr, dg, db: Integer);
var
  I,w2: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := (height/2) / 255;
  pw:=(width/4)/255;
  w2:=width div 2;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    Xrectangle(trunc(i*pw),trunc(i*ph),
     trunc(w2+1-i*pw),trunc(height-1-i*ph));
    Xrectangle(trunc(w2-1+i*pw),trunc(i*ph),
     trunc(width-1-i*pw),trunc(height-1-i*ph));
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradLNE(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  points:array[0..5] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := height / 255;
  pw:=width/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(i*pw),0);
    points[1]:=point(Trunc(i*pw),Trunc(height-1-i*ph));
    points[2]:=point(Trunc(width-1),Trunc(height-1-i*ph));
    points[3]:=point(Trunc(width-1),Trunc(height-1-i*ph-ph));
    points[4]:=point(Trunc(i*pw+pw),Trunc(height-1-i*ph-ph));
    points[5]:=point(Trunc(i*pw+pw),0);
    Xpoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradLNW(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw,ph: Real;
  points:array[0..5] of TPoint;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := height / 255;
  pw:=width/255;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    points[0]:=point(Trunc(width-1-i*pw),0);
    points[1]:=point(Trunc(width-1-i*pw),Trunc(height-1-i*ph));
    points[2]:=point(0,Trunc(height-1-i*ph));
    points[3]:=point(0,Trunc(height-1-i*ph-ph));
    points[4]:=point(Trunc(width-1-i*pw-pw),Trunc(height-1-i*ph-ph));
    points[5]:=point(Trunc(width-1-i*pw-pw),0);
    Xpoly(points);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradUpDown(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  ph: Real;
  w2:integer;
  gra:Trect;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Ph := height / 255;
  w2:=width div 2;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    gra:=rect(0,trunc(i*ph),w2,trunc(i*ph+ph));
    XFillrect(gra);
    gra:=rect(w2,trunc(height-1-i*ph-ph),width-1,trunc(height-1-i*ph));
    XFillrect(gra);
  end;
  swCanvas.Pen.Style := psSolid;
end;

procedure TjanShape.doGradLeftRight(fr, fg, fb, dr, dg, db: Integer);
var
  I: Integer;
  R, G, B : Byte;
  pw: Real;
  h2:integer;
  gra:TRect;
begin
  swCanvas.Pen.Style := psclear;
  swCanvas.Pen.Mode := pmCopy;
  Pw := width / 255;
  h2:=height div 2;
  for I := 0 to 255 do begin         //Make trapeziums of color
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    swCanvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    gra:=rect(trunc(i*pw),0,trunc(i*pw+pw),h2);
    XFillrect(gra);
    gra:=rect(trunc(width-1-i*pw-pw),h2,trunc(width-1-i*pw),height-1);
    XFillrect(gra);
  end;
  swCanvas.Pen.Style := psSolid;
end;


procedure TjanShape.PaintToCanvas(acanvas: TCanvas;Ax0,Ay0:integer;AScaleX,AscaleY:extended);
begin
  x0:=Ax0;
  y0:=Ay0;
  ScaleX:=AscaleX;
  ScaleY:=AscaleY;
  swCanvas:=aCanvas;
  swExternal:=true;
  Paint;
  swCanvas:=Canvas;
  swExternal:=false;
  x0:=0;
  y0:=0;
  ScaleX:=1;
  ScaleY:=1;
end;








procedure TjanShape.MouseDown(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
var pop:TjanShapeController;
    haspop:boolean;
    index:integer;
begin
  haspop:=false;
  OldLeft:=left;
  OldTop:=top;
  OldWidth:=width;
  OldHeight:=Height;
  if assigned(PopupMenu) then
    if (PopupMenu is TjanShapeController) then
    begin
      pop:=TjanShapeController(popupmenu);
      haspop:=true;
    end;
  if (ssshift in shift) and (button=mbleft) then
  begin
    if haspop and FActiveMouse then
       pop.SelectingShape (self);
  end
  else if button=mbleft then
  begin
    if haspop then
        if pop.MouseModeController then
          FMouseMode:=pop.MouseMode;
    isMouseDown:=true;
    selObjXX := X; selObjYY := Y;
    case FMouseMode of
      mmSizeObject:
      begin
        selObjXX:=width-x;
        selObjYY:=height-y;
      end;
     end;
  end;
  if assigned(onmousedown) then
    onmousedown(self,button,shift,x,y);
end;

procedure TjanShape.MouseMove(Shift: TShiftState; X, Y: Integer);
var obj:TjanShape;
    angle:extended;
    dx,dy:integer;
    pop:TjanShapecontroller;
    useGrid:boolean;
    GridSize:integer;
    warnController:boolean;
    NewLeft,NewTop:integer;

    function g(avalue:integer):integer;
    begin
      result:= avalue div GridSize * GridSize ;
    end;
begin
  if (FActiveMouse and IsMouseDown) then
  begin
    useGrid:=false;
    warnController:=false;
    if assigned(PopupMenu) then
      if (PopupMenu is TjanShapeController) then
      begin
        pop:=TjanShapeController(popupmenu);
        if pop.MouseModeController then
        begin
          warnController:=true;
          useGrid:=pop.MouseGrid;
          GridSize:=pop.MouseGridSize;
          if GridSize<2 then useGrid:=false;
        end;
      end;

    case FMouseMode of
      mmMoveObject:
      begin
        if not UseGrid then
        begin
          NewLeft:=Left+X-selObjXX;
          NewTop:=Top+Y-SelobjYY;
        end
        else
        begin
          NewLeft:=g(Left+X-selObjXX)-1;
          NewTop:=g(Top+Y-SelobjYY)-1;
        end;
        SetBounds(NewLeft,Newtop,Width,Height);
        if warnController then pop.MovingShape (self,NewLeft-Oldleft,NewTop-OldTop);
        OldLeft:=NewLeft;
        OldTop:=Newtop;
      end;
      mmSizeObject:
      begin
        if not useGrid then
         SetBounds(Left,Top,x+SelObjXX,y+SelObjYY)
        else
         SetBounds(Left,Top,g(x+SelObjXX)+1,g(y+SelObjYY)+1);
      end;
      mmMoveText:
      begin
        CaptionCentered :=false;
        if not useGrid then
        begin
        CaptionX :=X;
        CaptionY:=Y;
        end
        else
        begin
        CaptionX :=g(X);
        CaptionY:=g(Y);
        end;
      end;
      mmRotateText:
      begin
        CaptionCentered :=false;
        dy:=Height div 2 -y;
        dx:=x-(width div 2);
        if dx=0 then dx:=1;
        angle:=arctan2(dy,dx)/pi*180;
        CaptionAngle :=round(angle);
      end;
    end;
  end;


  if assigned(onmousemove) then
    onmousemove(self,shift,x,y);
end;

procedure TjanShape.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  isMouseDown:=false;
  if assigned(onmouseup) then
    onmouseup(self,button,shift,x,y);
end;

procedure TjanShape.SetActiveMouse(const Value: boolean);
begin
  FActiveMouse := Value;
end;

procedure TjanShape.SetMouseMode(const Value: TshapeMouseMode);
begin
  FMouseMode := Value;
end;



procedure TjanShape.SetUserVectorString(const Value: string);
var
  alist:TStringlist;
  c,i,j,p:integer;
  UV:array of TFloatPoint;
  UP:integer;
  vec:string;
begin
  if value='' then exit;
  p:=pos('=',value);
  if p=0 then exit;
  vec:=copy(value,p+1,length(value));
  alist:=Tstringlist.create;
  alist.commaText:=Vec;
  c:=alist.count;
  if (c=0) or ((c mod 2)<>0)or (c>100) then
  begin
    alist.free;
    exit;
  end;
  UP:=c div 2;
  setlength(UV,UP);
  j:=0;
  try
    for i:=0 to UP-1 do
    begin
      UV[i].x:=strtofloat(alist[j]);
      inc(j);
      UV[i].y:=strtofloat(alist[j]);
      inc(j);
    end;
  except
    alist.free;
    exit;
  end;
  alist.free;
  FUserVectorString := Value;
  UserPoints:=UP;
  SetLength(UserVector,UserPoints);
  for i:=0 to UserPoints-1 do
  begin
    UserVector[i].x:=UV[i].x;
    UserVector[i].y:=UV[i].y;
  end;
  invalidate;
end;


procedure TjanShape.SetPolyLineMode(const Value: boolean);
begin
  if value<>FPolyLineMode then
  begin
    FPolyLineMode := Value;
    invalidate;
  end;
end;


procedure TjanShape.SetSelected(const Value: boolean);
begin
  if value<>FSelected then
  begin
    FSelected := Value;
    invalidate;
  end;
end;

procedure TjanShape.SetGroupName(const Value: string);
begin
  FGroupName := Value;
end;

procedure TjanShape.SetConnectorN(const Value: string);
begin
  FConnectorN := Value;
end;

procedure TjanShape.SetConnectorS(const Value: string);
begin
  FConnectorS := Value;
end;

procedure TjanShape.SetConnectorE(const Value: string);
begin
  FConnectorE := Value;
end;

procedure TjanShape.SetConnectorW(const Value: string);
begin
  FConnectorW := Value;
end;

end.

